﻿// JScript 文件

function AlignTime(strTime)
{
	if(strTime.toString().length < 2)
	{
		return '0' + strTime;
	}
	return strTime;
}

function DateToString(date)
{
    return date.getFullYear()+"-"+AlignTime(date.getMonth()+1)+"-"+AlignTime(date.getDate())+" "
            +AlignTime(date.getHours())+":"+AlignTime(date.getMinutes())+":"+AlignTime(date.getSeconds());
}

function DateBox(id,bPop,bTimeOnly)
{
    this.id = id;
    this.bPop = bPop;
    this.bTimeOnly = bTimeOnly;
    this.onChange = function ()
    {
        g_bChange = true;
    }
    this.onEnterKey=new Function();
    DateBox.all[id]=this;
}
DateBox.all={};

DateBox.prototype=
{
    toString:function()
    {
        var strHtml = '<span  id="'+this.id+ '" style = "text-align:center;height:23px; background-color:#dcdcdc; padding:0;" >';
        if(!this.bTimeOnly)
        {
            strHtml += '<div id="'+this.id+'_calDiv" style="position:absolute; z-index:1"></div>\
                        <input class = "calendar" id="'+this.id+'_1" type="text" value = "2004-01-01" readonly = "readonly" style = " width:107px; margin:0;text-align:center; border-width:1px 0 1px 1px;border-style:solid;border-color:#7F9DB9;cursor: pointer;" onclick = "DateBox.evt.onclick(this,event)"/>';
            strHtml += '<input id="'+this.id+'_2"onkeypress="DateBox.evt.keypress(this,event)" style="border-width:1px 0 1px 0; border-style:solid;border-color:#7F9DB9;text-align:center; width:25px;" name = "hour" class = "hour" onfocus="DateBox.evt.focus(this,event)" onchange = "DateBox.evt.change(this,event)" type="text" maxlength=2 \
                           value="00"/>';
        }
        else    //隐藏日期控件，并且在时间控件上加左边框
        {
            strHtml += '<div id="'+this.id+'_calDiv" style="position:absolute; z-index:1"></div>\
                        <input class = "calendar" id="'+this.id+'_1" type="text" value = "2004-01-01" readonly = "readonly" style = "display:none;width:107px; margin:0;text-align:center; border-width:1px 0 1px 1px;border-style:solid;border-color:#7F9DB9;cursor: pointer;" onclick = "DateBox.evt.onclick(this,event)"/>';
            strHtml += '<input id="'+this.id+'_2"onkeypress="DateBox.evt.keypress(this,event)" style="border-width:1px 0 1px 1px; border-style:solid;border-color:#7F9DB9;text-align:center; width:28px;" name = "hour" class = "hour" onfocus="DateBox.evt.focus(this,event)" onchange = "DateBox.evt.change(this,event)" type="text" maxlength=2 \
                           value="00"/>';
        }
        
        strHtml += '<input type="text" value = ":"style = "border-width:1px 0 1px 0; border-style:solid;width:8px;border-color:#7F9DB9;" disabled = "disabled" class = "separator" \
        /><input id="'+this.id+'_3"onkeypress="DateBox.evt.keypress(this,event)" style="border-width:1px 0 1px 0; border-style:solid;border-color:#7F9DB9;text-align:center; width:25px;" name = "minute" class = "minute" onfocus="DateBox.evt.focus(this,event)" onchange = "DateBox.evt.change(this,event)" type="text" maxlength=2 \
        value="00"/><input type="text" value = ":" style = "border-width:1px 0 1px 0; border-style:solid;border-color:#7F9DB9;width:8px;" disabled = "disabled" class = "separator" \
        /><input id="'+this.id+'_4"onkeypress="DateBox.evt.keypress(this,event)" style="border-width:1px 1px 1px 0; border-style:solid;border-color:#7F9DB9;text-align:center; width:25px;" name = "second" class = "second" onfocus="DateBox.evt.focus(this,event)" onchange = "DateBox.evt.change(this,event)" type="text" maxlength=2 \
        value="00"/></span>';
        return strHtml;
    },   
    getValue:function() //返回值：[yyyy-mm-dd ]HH:MM:SS
    {
        var dateValue = "";
        if(!this.bTimeOnly)
        {
            dateValue = document.getElementById(this.id+"_1").value+" ";
        }
        dateValue += document.getElementById(this.id+"_2").value+":";
        dateValue += document.getElementById(this.id+"_3").value+":";
        dateValue += document.getElementById(this.id+"_4").value;
 
        return dateValue;
    },
    setValue:function(setDatevalue) //参数Array([yyyy-mm-dd], HH, MM, SS);
    {
        if(setDatevalue==null)
        {
            return;

        }
        var offset = 0;
        if(!this.bTimeOnly)
        {
            document.getElementById(this.id+"_1").value = setDatevalue[0];
            offset = 1;
        }        
        document.getElementById(this.id+"_2").value = setDatevalue[offset+0];
        document.getElementById(this.id+"_3").value = setDatevalue[offset+1];
        document.getElementById(this.id+"_4").value = setDatevalue[offset+2];
    }
}    

DateBox.evt=
{
    onclick:function(obj,evt)
    {
        var id = obj.id.replace(/_1/,"");
        var calObj = document.getElementById(id+"_calDiv");
        if (DateBox.all[id].bPop)
        {
            PopCalendar(obj,calObj, document.getElementById(id+"_2"));
        }
    },
    focus:function(obj,evt)
    {
        obj.select();
    },
    change:function(obj,evt)
    {
        var id = obj.id.replace(/_\d/,"");
        
        if(obj.value.length == 1)
        {
            obj.value = "0"+obj.value;
        }
        if(obj.value.length == 0)
        {
            obj.value = "00";
        }
        DateBox.all[id].onChange();
    },
    keypress:function(obj,evt)
    {
        var parent = obj.parentNode;
        var date = parent.getElementsByTagName("input");
        var key=evt.charCode||evt.keyCode;
        var pos=DateBox.evt.getSelection(obj);
        var value=obj.value;
        var c=String.fromCharCode(key);
        if(key>=48 && key<=57)
        {
            value=""+value.substring(0,pos.start) + c + value.substring(pos.end,value.length);
            if(obj.name == "hour")
            {
                if(parseInt(value,10)<=23)
                {
                    if(value.length ==2)
                    {
                        setTimeout(date[3].id + ".focus();"+date[3].id+".select();",200);
                    }
                    return true;
                }
                else
                {
                    if(evt.preventDefault)
                    evt.preventDefault();
                    evt.returnValue=false;
                    return false;
                }
            }
            if(obj.name == "minute" || obj.name == "second")
            {
                if(parseInt(value,10)<=59)
                {
                    if(value.length ==2)
                    {
                        setTimeout(date[5].id + ".focus();"+date[5].id+".select();",200);
                    }
                    return true;
                }
                else
                {
                    if(evt.preventDefault)
                    evt.preventDefault();
                    evt.returnValue=false;
                    return false;
                }
            }
        }
        else
        {
            if(evt.preventDefault)
            evt.preventDefault();
            evt.returnValue=false;
        }
    },
    //获取选区位置
    getSelection:function(oInput)
    {
        var T=this;
        if(oInput.createTextRange)
        {
            var s=document.selection.createRange().duplicate();
            s.moveStart("character",-oInput.value.length);
            var p1=s.text.length;
            var s=document.selection.createRange().duplicate();
            s.moveEnd("character",oInput.value.length);
            var p2=oInput.value.lastIndexOf(s.text);
            if(s.text=="")
            {
                p2=oInput.value.length;
            }
            return {start:p2,end:p1};
        }
        else 
        {
            return {start:oInput.selectionStart,end:oInput.selectionEnd};
        }
    }
}  
/******************************************************************************
*
*   日期选择组合控件
*
*******************************************************************************/
function DateTicker(id)
{
    this.id = id;
    DateTicker.all[id]=this;
}

DateTicker.all = {};

DateTicker.prototype=
{
    toString:function()
    {
        var strHtml = '<span  id="'+this.id+ '" style = "text-align:center;height:20px;line-height:20px; padding:0;" >';

        strHtml += '<div id="'+this.id+'_calDiv" style="position:absolute; z-index:1"></div>\
                        <input id="'+this.id+'_1" type="text" value = "2004-01-01" readonly = "readonly" style = "width:100px; margin:0;text-align:center;border:solid 1px #7F9DB9; cursor:pointer;" onclick = "DateTicker.evt.onclick(this,event)"/> \
                        <img src="res/dateImageButton.jpg" style="border:0px; margin:0px;vertical-align:middle;cursor: pointer;" onclick="DateTicker.evt.onclick('+this.id+'_1'+',event)"/> \
                        </span>';
        return strHtml;
    },   
    getValue:function() //返回值：yyyy-mm-dd
    {
        return document.getElementById(this.id+"_1").value;
    },
    setValue:function(setDatevalue) //参数yyyy-mm-dd
    {
        if(setDatevalue==null)
        {
            return;

        }
        document.getElementById(this.id+"_1").value = setDatevalue;
    }
}    

DateTicker.evt=
{
    onclick:function(obj,evt)
    {
        var id = obj.id.replace(/_1/,"");
        var calObj = document.getElementById(id+"_calDiv");
        
        PopCalendar(obj,calObj, null);
    }
}
