#!/bin/sh

#define path
PCI_BOOT_PATH=/mnt/mtd/modules/pci_boot/
PCIT_DRV_PATH=/lib/modules/2.6.24-rt1-hi3520v100/misc/
MCC_DRV_PATH=/lib/modules/2.6.24-rt1-hi3520v100/misc/
MPP_KO_PATH=/mnt/mtd/modules/
PCIV_KO_PATH=/mnt/mtd/modules/

if [ ! -d $PCI_BOOT_PATH ];	then
	echo "$PCI_BOOT_PATH not exist! "
	exit 1
fi

#boot slave chip
modprobe mmz mmz=ddr,0,0xc0000000,32M
insmod $PCIT_DRV_PATH/pci_multi_boot.ko path=$PCI_BOOT_PATH
rmmod pci_multi_boot
rmmod mmz
echo "************************ boot slave ok ********************************"

#insmod pci trans
insmod $PCIT_DRV_PATH/pci_hwhal_host.ko
insmod $PCIT_DRV_PATH/hi3520_pci_trans_host.ko
echo "************************ load pci trans ok ********************************"

#insmod pci msg
insmod $MCC_DRV_PATH/hi_hw_adp.ko
insmod $MCC_DRV_PATH/pcicom.ko
echo "************************ load pci mcc ok ********************************"

#insmod mpp 
cd $MPP_KO_PATH;
./load_master -i;

#insmod pciv
insmod $PCIV_KO_PATH/hi3520_pciv.ko;
echo "************************ load hi3520 mpp ok ********************************"

