﻿// JScript 文件
var g_curMotionSetChannel = -1;
var cfg_motion_header = new Array(str_ch,str_enabel,str_holdtimes,str_trigger,str_area);
var cfg_motion_ptz_header = new Array(str_ch,str_type,str_no);
/***********************************************************************************/
/******************移动侦测报警配置页面动态生成表格*********************************/
/***********************************************************************************/

function OnLoadCfgMotionAlarm()
{
    ApplyXmlLang("cfg_motion_alarm.xml");
    g_curConfigIndex = 52;
    CreateListMotion(id_motion_alarm, 5,cfg_motion_header, g_channelList.length);		
    GenSelectListEx(all_motion_hold_time, g_alarmOutHoldTime);
    
    
    GenCheckGroup(motion_trigger_out,true,g_alarmoutList,STR_MOTION_TO_ALARM_OUT+"_ctrl", 4, Btrigger);
    if(g_alarmoutList.length > 1)
    {
        motion_trigger_out.className += " " +"user_gen_table";
    }
    else
    {
        motion_trigger_out.style.border = "0";
        motion_trigger_out.rows[0].cells[0].style.border = "0";
    }
    
    if (g_supportFunctions.IsSupportAlarm()) 
    { 
        motion_trigger_out.disabled = "disabled";
    }
  
    GenCheckGroup(motion_trigger_record,true, g_channelList,STR_MOTION_TO_RECORD+"_ctrl", 4, Btrigger);
    GenCheckGroup(motion_snap, true,g_channelList,STR_MOTION_TO_SNAP+"_ctrl", 4, Btrigger);
    MotionTriggerPTZ(id_motion_ptz, 3,cfg_motion_ptz_header, g_channelList.length);
    var xmlConfigReq = CreateConfigReqXml(motion_alarm_config_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return;
	}

	//zld 2010/8/18

    if (g_xmlDoc!=null)
    {
        delete g_xmlDoc;
        g_xmlDoc=null;
    }

    g_xmlDoc = FormatToXmlDOM(xmlConfigReply);
	g_xmlDoc.async = false;
	//g_xmlDoc.loadXML(xmlConfigReply);
	var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	UpdateValues(paramElements, true);
	cfgCopy2All(motion_all_cfg,id_motion_alarm,id_motion_all);
	motion_area_button.disabled = true;
	
	AlarmGetCruiseList(paramElements);
	
	all_motion_enable.checked = true;
    all_motion_hold_time.value = 10;
    //zld 2010/8/26
	Align();
}

function LoadDefaultCfgMotion()
{
    if(GetDefaultCfg(motion_alarm_config_array))
    {
        onMotionPTZCancel();
        
        var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
        UpdateValues(paramElements, true);
	    cfgCopy2All(motion_all_cfg,id_motion_alarm,id_motion_all);
	    motion_area_button.disabled = true;
	    
	    AlarmGetCruiseList(paramElements);
	    
	    g_bChange = true;
	    bTrigger = true;
    }
}

function CreateListMotion(htmlObj, colNum, colHeaders, rowInitNum)
{
    //zld 2010/10/22
    var isIE = /msie/i.test(navigator.userAgent);
	var strOuterHTML = htmlObj.outerHTML.toLowerCase();
	var lengthLimit = strOuterHTML.indexOf("</tbody>");
	strOuterHTML = strOuterHTML.substr(0, lengthLimit);
	//添加标题行
	strOuterHTML += "<tr class = 'table_head_bgcolor'>";
	for(var i = 0; i < colNum; i++)
	{
		strOuterHTML += "<td style = \"text-align:center\">" + colHeaders[i] + "</td>";
	}
	strOuterHTML += "</tr>";
	//添加数据行
	for(var i = 0; i < rowInitNum; i++)
	{
	    if (isIE) 
	    {
	        strOuterHTML += "<tr>";
		    strOuterHTML += "<td style = \"text-align:center;width:50px;\">"+(i+1)+"</td>";
	        strOuterHTML += "<td><input type = \"checkbox\" name = \"motion_enable\" onchange = \"g_bChange = true;\" /></td>";
	        strOuterHTML +="<td><select style = \"width:130px\" name = \"motion_hold_time\" onchange = \"g_bChange = true;\"></select></td>";
	        strOuterHTML += "<td align = \"center\" style = \"width:225px\"><input style = \"width:145px; height:25px; border:0; background:url(res/145x25_btn.jpg);cursor:pointer;\" type = \"button\" value = "+set_button+" onclick = \"OnDisOrHidMotion("+i+")\"/></td>";
            strOuterHTML += "<td align = \"center\" style = \"width:225px\"><input style = \"width:145px; height:25px; border:0; background:url(res/145x25_btn.jpg);cursor:pointer;\" type = \"button\" value = "+set_button+" onclick='GotoMotionAreaSet("+i+")'/></td>";
		    strOuterHTML += "</tr>";
	    }
	    else
	    {
	        strOuterHTML += "<tr>";
		    strOuterHTML += "<td style = \"text-align:center;width:50px;\">"+(i+1)+"</td>";
	        strOuterHTML += "<td style = \"text-align:center;width:80px;\"><input type = \"checkbox\" name = \"motion_enable\" style = \"width:30px;\" onchange = \"g_bChange = true;\" /></td>";
	        strOuterHTML +="<td><select style = \"width:130px\" name = \"motion_hold_time\" onchange = \"g_bChange = true;\"></select></td>";
	        strOuterHTML += "<td align = \"center\" style = \"width:225px\"><input style = \"width:145px; height:25px; border:0; background:url(res/145x25_btn.jpg);cursor:pointer;\" type = \"button\" value = "+set_button+" onclick = \"OnDisOrHidMotion("+i+")\"/></td>";
            strOuterHTML += "<td align = \"center\" style = \"width:225px\"><input style = \"width:145px; height:25px; border:0; background:url(res/145x25_btn.jpg);cursor:pointer;\" type = \"button\" value = "+set_button+" onclick='GotoMotionAreaSet("+i+")'/></td>";
		    strOuterHTML += "</tr>";
	    }
		
	}
	strOuterHTML += "</tbody></table>";
	var parentNode = htmlObj.parentElement;
	parentNode.innerHTML = strOuterHTML;
	for(var i = 0; i < rowInitNum; i++)
	{
	    GenSelectListEx(document.getElementsByName("motion_hold_time")[i], g_alarmOutHoldTime);
	}
	htmlObj = parentNode.childNodes[0];
}
/***********************************************************************************/
/*********************motion配置页面云台动态生成表格********************************/
/***********************************************************************************/

function MotionTriggerPTZ(htmlObj, colNum, colHeaders, rowInitNum)
{
	var strOuterHTML = htmlObj.outerHTML.toLowerCase();
	var lengthLimit = strOuterHTML.indexOf("</tbody>");
	strOuterHTML = strOuterHTML.substr(0, lengthLimit);
	//添加标题行
	strOuterHTML += "<tr class = 'table_head_bgcolor'>";
	for(var i = 0; i < colNum; i++)
	{
		strOuterHTML += "<td style = \"text-align:center\">" + colHeaders[i] + "</td>";
	}
	strOuterHTML += "</tr>";
	//添加数据行
	for(var i = 1; i < rowInitNum + 1; i++)
	{
		strOuterHTML += "<tr>";
		strOuterHTML += "<td style = \"width:180px;text-align:center\">"+i+"</td>";
	    strOuterHTML +="<td><select style = \"width:260px\" name = \"ptz_type\" onchange = \"onMotionChangePtzType(this,"+i+");bTrigger = true\"></select></td>";
	    strOuterHTML +="<td><select style = \"width:260px\" name = \"ptz_number\" disabled = \"disabled\" onchange = \"bTrigger = true;\"></select></td>";
		strOuterHTML += "</tr>";
	}
	strOuterHTML += "</tbody></table>";
	var parentNode = htmlObj.parentElement;
	parentNode.innerHTML = strOuterHTML;
	for(var i = 1; i < rowInitNum + 1; i++)
	{
	    GenSelectListEx(document.getElementsByName("ptz_type")[i-1], g_motionPTZType);
	}
	htmlObj = parentNode.childNodes[0];
}

function OnEnterMotinoArea(channel)
{
    //zld 2010/10/16
    var motion_oper=document.getElementsByName("motion_oper");
    motion_oper[0].checked="checked";
//	var motion_oper=document.getElementsByName("motion_oper");
//	if (g_curMotionAreaState==0) 
//	{
//	    motion_oper[0].checked="checked";
//	}
//	else
//	{
//	    motion_oper[1].checked="checked";
//	}
    WebClient.SetVisible(3 | (channel << 8));
//读取本通道的motion区域信息
//调用OCX把motion信息数据传入ocx
//调用ocx把当前编辑模式传入ocx;
    channel = parseInt(channel,10);
    g_curMotionSetChannel = channel;
    var cmdElements = g_xmlDoc.documentElement.childNodes;
    if(cmdElements.length > 0)
    {
        var paramElements = cmdElements[0].childNodes;
        for(var i = 0; i < paramElements.length; i++)
		{
			var dataName = paramElements[i].attributes.getNamedItem("name").nodeValue;
			if(dataName == STR_MOTION_AREA)
			{
				break;	
			}
		}
		if(i == cmdElements.length)
		{
		    window.alert(no_motion_info_tip);
		    return;
		}
		
		var strMotionInfo = paramElements[i+channel].childNodes[0].nodeValue;
		
		var motionValues = strMotionInfo.split('+');
		SetSliderPos(sensi_bk, sensi_thumb, parseInt(motionValues[2],10)+1);
		
		WebClient.SetMotionAreaInfo(strMotionInfo);
		
    }
    
    SetAreaEditMode(0);
}

function SaveMotionArea()
{
    var strMotionInfo = WebClient.GetMotionAreaInfo();
    
    var cmdElements = g_xmlDoc.documentElement.childNodes;
    if(cmdElements.length > 0)
    {
        var paramElements = cmdElements[0].childNodes;
        for(var i = 0; i < paramElements.length; i++)
		{
			var dataName = paramElements[i].attributes.getNamedItem("name").nodeValue;
			if(dataName == STR_MOTION_AREA)
			{
				break;
			}
		}
		if(i == cmdElements.length)
		{
		    window.alert(no_motion_info_tip);
		}
		
		var motionValues = strMotionInfo.split('+');
		motionValues[2] = GetSliderPos(sensi_bk, sensi_thumb)-1;
		strMotionInfo = motionValues.join('+');
		
		if(paramElements[i+g_curMotionSetChannel].childNodes[0].nodeValue != strMotionInfo)
		{
		    paramElements[i+g_curMotionSetChannel].childNodes[0].nodeValue = strMotionInfo;
		    g_bChange = true;
		}
    }
}

function SetAreaEditMode(editMode)
{
    //zld 2010/10/16
    //g_curMotionAreaState=editMode;
    WebClient.SetMotionEditMode(editMode);
}

function MotionMarkAll()
{
    WebClient.SetMotionEditMode(2);
}

function MotionInvertMark()
{
    WebClient.SetMotionEditMode(3);
}


function GotoMotionAreaSet(channel)
{
    div_config.style.display = "none";
	div_ocx.style.display = "";
	WebClient.style.display = "";
	div_live.style.display = "";
	div_ocx.style.left = div_main_menu.offsetLeft+5;
	div_ocx.style.top = div_main_menu.offsetTop+div_main_menu.offsetHeight;
	div_ocx.style.width = 770;
	//zld 2010/9/11
	WebClient.style.width = "";
	WebClient.style.width = "770px";
	//zld 2010/10/12
	var isIE = /msie/i.test(navigator.userAgent); 
	if (isIE) 
	{
	    ocx_alt_label.style.display="";
	}
	
//	WebClient.SetVisible(3 | (channel << 8));
	g_xmlhttp.open("get", "body_html/body_motion_area.html", false);
	SafeHttpSend(g_xmlhttp, null);
//	g_xmlhttp.onreadystatechange = function ()
	{
		if(g_xmlhttp.readyState == 4)
		{
			div_live.innerHTML = g_xmlhttp.responseText;
			CreateSlider(div_motion_sensi, sensi_bk, sensi_thumb, sensi_tip, 1, 8);
			SetSliderPos(sensi_bk, sensi_thumb, 4);
			GenSelectListEx(motion_area_channel_list, g_channelList);
			motion_area_channel_list.value = channel;
			
			//SetAreaEditMode(0);
// 			div_motion_area_channel.innerHTML = channel_string + (channel+1);
            EdgeCtrl(div_ocx,32);
			ApplyXmlLang("cfg_motion_area.xml");
			
			OnEnterMotinoArea(channel);
		}
	}
	
	//zld 2010/9/7
	if (document.getElementById("div_ocx").offsetHeight>document.getElementById("div_live").offsetHeight) 
	{
	    var div_live_height= document.getElementById("div_ocx").offsetHeight+5;
	    document.getElementById("div_live").style.height = "";
	    document.getElementById("div_live").style.height = div_live_height+"px";
	    //zld 2010/10/14
	    if (isIE) 
	    {
	        document.getElementById("div_ocx").style.height = "";
	        document.getElementById("div_ocx").style.height = div_live_height+"px";
	    }
	    
	    //zld 2010/10/9
	    WebClient.style.height = div_live_height+"px";
	    //zld 2010/10/14
        if (!isIE) 
        {
            var work_area_height = div_live_height+40;
            document.getElementById("work_area").style.height =work_area_height+"px";
        }
	}
	else
	{
	    var div_ocx_height= document.getElementById("div_live").offsetHeight-5;
	    document.getElementById("div_ocx").style.height = "";
	    document.getElementById("div_ocx").style.height = div_ocx_height+"px";
	    //zld 2010/10/9
	    WebClient.style.height = div_ocx_height+"px";
	    //zld 2010/10/14
	    if (!isIE) 
        {
            var work_area_height = div_ocx_height+40;
            document.getElementById("work_area").style.height =work_area_height+"px";
        }
	}
	
}

function ExitMotionAreaSet()
{
    WebClient.SetVisible(0);
    //zld 2010/9/2
    div_ocx.style.width="0px";
    div_ocx.style.height="0px";
	//div_ocx.style.display = "none";
	//zld 2010/9/13
    WebClient.style.width="0px";
    WebClient.style.height="0px";
	//WebClient.style.display = "none";
	div_live.style.display = "none";
	div_live.innerHTML = "";
	div_config.style.display = "";
    EdgeCtrl(div_config_index,72);
}

/*********************motion报警界面显示与隐藏控制**********************/
function OnDisOrHidMotion(index)
{
    var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
    UpdateBooleanTrigger(paramElements, STR_MOTION_TO_BUZZ, STR_MOTION_TO_BUZZ+"_ctrl", false);
    UpdateBooleanTrigger(paramElements, STR_MOTION_TO_EMAIL, STR_MOTION_TO_EMAIL+"_ctrl", false);
    UpdateAlarmTrigger(paramElements, STR_MOTION_TO_ALARM_OUT, STR_MOTION_TO_ALARM_OUT+"_ctrl", false);
    UpdateAlarmTrigger(paramElements, STR_MOTION_TO_RECORD, STR_MOTION_TO_RECORD+"_ctrl", false);
    UpdateAlarmTrigger(paramElements, STR_MOTION_TO_SNAP, STR_MOTION_TO_SNAP+"_ctrl", false);
    UpdateBigView(paramElements, STR_MOTION_TO_BIGVIEW, STR_MOTION_TO_BIGVIEW+"_ctrl", false);
    UpdateAlarmToPtz(paramElements, false, g_curchannel_motion);
    div_motion_trigger.style.display = "";
//     id_cp.style.display = "";
    motion_index_num.innerHTML = "<b>"+channel_string+(index+1)+"</b>";
    g_curchannel_motion = index;
    for(i = 0 ; i < g_channelList.length; i++)
    {
        document.getElementsByName("ptz_type")[i].disabled = false;
        document.getElementsByName("ptz_number")[i].disabled = false;
    }
    for(k = 0; k < g_bUpdataChannel.length; k++)
    {
        if(k != index)
        {
            g_bUpdataChannel[k] = 0;
        }
        else
        {
            g_bUpdataChannel[k] = 1;
        }
	}
	GenSelectListEx(motion_to_bigview_ctrl, g_bigViewList);
    var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
    UpdateBooleanTrigger(paramElements, STR_MOTION_TO_BUZZ, STR_MOTION_TO_BUZZ+"_ctrl", true);
    UpdateBooleanTrigger(paramElements, STR_MOTION_TO_EMAIL, STR_MOTION_TO_EMAIL+"_ctrl", true);
    UpdateAlarmTrigger(paramElements, STR_MOTION_TO_ALARM_OUT, STR_MOTION_TO_ALARM_OUT+"_ctrl", true);
    UpdateAlarmTrigger(paramElements, STR_MOTION_TO_RECORD, STR_MOTION_TO_RECORD+"_ctrl", true);
    UpdateAlarmTrigger(paramElements, STR_MOTION_TO_SNAP, STR_MOTION_TO_SNAP+"_ctrl", true);
    UpdateBigView(paramElements, STR_MOTION_TO_BIGVIEW, STR_MOTION_TO_BIGVIEW+"_ctrl", true);
    UpdateAlarmToPtz(paramElements, true);
    document.getElementsByName("ptz_type")[index].disabled = "disabled";
    document.getElementsByName("ptz_number")[index].disabled = "disabled";
//     GenCpList(cp_config_motion,index, g_channelList);
    
    UpdateCheckItems(motion_trigger_out);
    UpdateCheckItems(motion_trigger_record);
    UpdateCheckItems(motion_snap);
    
    Align();
    EdgeCtrl(div_config_index,72);
    location.href = "#motion_all_label";
}
//Motion ptz save
function onMotionPTZSave()
{
    if(!bTrigger)
    {
        window.alert(cfg_nochange_tip);
    }
    else
    {
        var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
        UpdateBooleanTrigger(paramElements, STR_MOTION_TO_BUZZ, STR_MOTION_TO_BUZZ+"_ctrl", false);
        UpdateBooleanTrigger(paramElements, STR_MOTION_TO_EMAIL, STR_MOTION_TO_EMAIL+"_ctrl", false);
        UpdateAlarmTrigger(paramElements, STR_MOTION_TO_ALARM_OUT, STR_MOTION_TO_ALARM_OUT+"_ctrl", false);
        UpdateAlarmTrigger(paramElements, STR_MOTION_TO_RECORD, STR_MOTION_TO_RECORD+"_ctrl", false);
        UpdateAlarmTrigger(paramElements, STR_MOTION_TO_SNAP, STR_MOTION_TO_SNAP+"_ctrl", false);
        UpdateBigView(paramElements, STR_MOTION_TO_BIGVIEW, STR_MOTION_TO_BIGVIEW+"_ctrl", false);
        UpdateAlarmToPtz(paramElements, false, g_curchannel_motion);
        div_motion_trigger.style.display = "none";
	    Align();
        EdgeCtrl(div_config_index,72);
    }
    
    for(k = 0; k < g_bUpdataChannel.length; k++)
    {
        g_bUpdataChannel[k] = 0;
	}
}
function onMotionPTZCancel()
{
    div_motion_trigger.style.display = "none";
    bTrigger = false;
	Align();
    EdgeCtrl(div_config_index,72);
    
    for(k = 0; k < g_bUpdataChannel.length; k++)
    {
        g_bUpdataChannel[k] = 0;
	}
}
function onMotionChangePtzType(obj,index)
{
    //zld 2010/8/20
    var ptz_number=document.getElementsByName("ptz_number");
     if(obj.value == -1)//null
     {
        ptz_number[index-1].disabled = true;
        ptz_number[index-1].innerHTML = "";
     }
	 if(obj.value == 6)	//g_cruiseList
	 {
        ptz_number[index-1].disabled = false;
        ptz_number[index-1].innerHTML = "";
        if(g_cruiseList[index-1].length == 0)
        {
            GenSelectListEx(ptz_number[index-1], new Array(new CSelectOptionInfo("- - -", -1)));
            return;
        }
        GenSelectListEx(ptz_number[index-1], g_cruiseList[index-1]);
	 }		
	 if(obj.value == 3)	//g_presetList
	 {			
        ptz_number[index-1].disabled = false;
        ptz_number[index-1].innerHTML = "";
        GenSelectListEx(ptz_number[index-1], g_presetList);
	 }
	 if(obj.value == 7)	//track
	 {			
        ptz_number[index-1].disabled = false;
        ptz_number[index-1].innerHTML = "";
        GenSelectListEx(ptz_number[index-1], g_trackList);
	 }
}
function disAllMotion()
{
    div_motion_trigger.style.display = "";
//     id_cp.style.display = "none";
    motion_index_num.innerHTML = "<b>"+str_all_channel+"</b>";
    
    UpdateCheckItems(motion_trigger_out);
    UpdateCheckItems(motion_trigger_record);
    UpdateCheckItems(motion_snap);
    
	Align();
    EdgeCtrl(div_config_index,72);
    
    location.href = "#motion_all_label";
}