﻿// JScript 文件
var cfg_record_osd_header = new Array(str_ch,str_OSDposition,str_OSDposition,str_timestamp, str_stamp_position);
var g_camNameOsd = null;
var g_timeStamp = null;
var g_bTimeStampPosSet = false;
var g_curSetChannel = -1;


function OsdInfo(bEnable, xPos, yPos)
{
    this.bEnable = bEnable;
    this.xPos = xPos;
    this.yPos = yPos;
}

function LoadDefaultCfgRecOSD()
{
    if(GetDefaultCfg(osd_config_array))
    {
        var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	    UpdateOsdInfo(paramElements, true);
	    cfgCopy2All(rec_osd_all_cfg,id_record_osd_cfg,id_rec_osd_all);
	    g_bChange = true;
	    //zld 2010/9/1
	    Align();
    }
}

function OnLoadCfgRecOSD()      
{
    ApplyXmlLang("cfg_rec_osd.xml");
    CreateListRecOSD(id_record_osd_cfg,5,cfg_record_osd_header,g_channelList.length);
	var xmlConfigReq = CreateConfigReqXml(osd_config_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return;
	}

	//zld 2010/8/18

    if (g_xmlDoc!=null)
    {
        delete g_xmlDoc;
        g_xmlDoc=null;
    }
    g_xmlDoc = FormatToXmlDOM(xmlConfigReply);
	g_xmlDoc.async = false;
	//g_xmlDoc.loadXML(xmlConfigReply);
	var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
//  window.alert(xmlConfigReply);
    UpdateOsdInfo(paramElements, true);
    cfgCopy2All(rec_osd_all_cfg,id_record_osd_cfg,id_rec_osd_all);
    
    //zld 2010/8/26
	Align();
}
function CreateListRecOSD(htmlObj, colNum, colHeaders, rowInitNum)
{
    //zld 2010/10/22
    var isIE = /msie/i.test(navigator.userAgent);
	var strOuterHTML = htmlObj.outerHTML.toLowerCase();
	var lengthLimit = strOuterHTML.indexOf("</tbody>");
	strOuterHTML = strOuterHTML.substr(0, lengthLimit);
	//添加标题行
	strOuterHTML += "<tr class = 'table_head_bgcolor'>";
	for(var i = 0; i < colNum; i++)
	{
		strOuterHTML += "<td style = \"text-align:center\">" + colHeaders[i] + "</td>";
	}
	strOuterHTML += "</tr>";
	//添加数据行
	for(var i = 1; i < rowInitNum + 1; i++)
	{
	    if (isIE) 
	    {
	        strOuterHTML += "<tr>";
	        strOuterHTML += "<td style = \"width:50px;text-align:center\">"+i+"</td>";
	        strOuterHTML += "<td><input type = \"checkbox\" name = \"name_osd\" style = \"width:100px;\" onchange = \"g_bChange = true;\" /></td>";
	        strOuterHTML += "<td align = \"center\" style = \"width:222px\"><input style = \"width:145px; height:25px; border:0; background:url(res/145x25_btn.jpg);cursor:pointer;\" type = \"button\" value = "+str_setting+" onclick = \"BeginPositionSet(false, "+(i-1)+")\"/></td>";
	        strOuterHTML += "<td><input type = \"checkbox\" name = \"time_stamp\" style = \"width:100px;\" onchange = \"g_bChange = true;\"/></td>";
	        strOuterHTML += "<td align = \"center\" style = \"width:222px\"><input style = \"width:145px; height:25px; border:0; background:url(res/145x25_btn.jpg);cursor:pointer;\" type = \"button\" value = "+str_setting+" onclick = \"BeginPositionSet(true, "+(i-1)+")\"/></td>";
		    strOuterHTML += "</tr>";
	    }
	    else
	    {
	        strOuterHTML += "<tr>";
	        strOuterHTML += "<td style = \"width:50px;text-align:center\">"+i+"</td>";
	        strOuterHTML += "<td style = \"width:100px;text-align:center\"><input type = \"checkbox\" name = \"name_osd\" style = \"width:30px;\" onchange = \"g_bChange = true;\" /></td>";
	        strOuterHTML += "<td align = \"center\" style = \"width:222px\"><input style = \"width:145px; height:25px; border:0; background:url(res/145x25_btn.jpg);cursor:pointer;\" type = \"button\" value = "+str_setting+" onclick = \"BeginPositionSet(false, "+(i-1)+")\"/></td>";
	        strOuterHTML += "<td style = \"width:100px;text-align:center\"><input type = \"checkbox\" name = \"time_stamp\" style = \"width:30px;\" onchange = \"g_bChange = true;\"/></td>";
	        strOuterHTML += "<td align = \"center\" style = \"width:222px\"><input style = \"width:145px; height:25px; border:0; background:url(res/145x25_btn.jpg);cursor:pointer;\" type = \"button\" value = "+str_setting+" onclick = \"BeginPositionSet(true, "+(i-1)+")\"/></td>";
		    strOuterHTML += "</tr>";
	    }
		
	}
	strOuterHTML += "</tbody></table>";
	var parentNode = htmlObj.parentElement;
	parentNode.innerHTML = strOuterHTML;
	htmlObj = parentNode.childNodes[0];
}
function UpdateOsdInfo(paramElements, bXml2Html)
{
    //zld 2010/10/11
    var time_stamp=document.getElementsByName("time_stamp");
    var name_osd=document.getElementsByName("name_osd");
    var rec_osd_all_cfg = document.getElementById("rec_osd_all_cfg");
    var all_time_stamp = document.getElementsByName("all_time_stamp");
    var all_name_osd = document.getElementsByName("all_name_osd");
    
    if(osd_position_set_pane.style.display == "")
    {
        EndPositionSet(true);
    }
    for(var i = 0; i < paramElements.length; i++)
    {
        if(paramElements[i].getAttribute("name") == STR_TIME_STAMP_INFO)
        {
            if(bXml2Html)
            {
                g_timeStamp = new Array();
                for(var k = i; k < (i+g_channelList.length); k++)
                {
                    var osdData = paramElements[k].childNodes[0].nodeValue.split('+');
                    g_timeStamp[k-i] = new OsdInfo(osdData[2], osdData[0], osdData[1]);
                    time_stamp[k-i].checked = ((osdData[2] != '0') ? true : false);
                }
            }
            else
            {
                for(var k = i; k < (i+g_channelList.length); k++)
                {
                    if(rec_osd_all_cfg.checked)
                    {
                        for(var a = 0; a < (g_channelList.length); a++)
                        {
                            if(all_time_stamp[0].checked)
                            {
                                g_timeStamp[a].bEnable = "1";
                            }
                            else
                            {
                                g_timeStamp[a].bEnable = "0";
                            }
                        }
                    }
                    else
                    {
                        g_timeStamp[k-i].bEnable = (time_stamp[k-i].checked ? '1' : '0');
                    }
                    var osdData = new Array(g_timeStamp[k-i].xPos, g_timeStamp[k-i].yPos, g_timeStamp[k-i].bEnable);
                    paramElements[k].childNodes[0].nodeValue = osdData.join('+');
                }
            }
            i += g_channelList.length-1;
        }
        else if(paramElements[i].getAttribute("name") == STR_CAM_NAME_STAMP)
        {
            if(bXml2Html)
            {
                g_camNameOsd = new Array();
                for(var k = i; k < (i+g_channelList.length); k++)
                {
                    var osdData = paramElements[k].childNodes[0].nodeValue.split('+');
                    g_camNameOsd[k-i] = new OsdInfo(osdData[2], osdData[0], osdData[1]);
                    name_osd[k-i].checked = ((osdData[2] != '0') ? true : false);
                }
            }
            else
            {
                for(var k = i; k < (i+g_channelList.length); k++)
                {
                    if(rec_osd_all_cfg.checked)
                    {
                        for(var a = 0; a < (g_channelList.length); a++)
                        {
                            if(all_name_osd[0].checked)
                            {
                                g_camNameOsd[a].bEnable = "1";
                            }
                            else
                            {
                                g_camNameOsd[a].bEnable = "0";
                            }
                        }
                    }
                    else
                    {
                        g_camNameOsd[k-i].bEnable = (name_osd[k-i].checked ? '1' : '0');
                    }
                    var osdData = new Array(g_camNameOsd[k-i].xPos, g_camNameOsd[k-i].yPos, g_camNameOsd[k-i].bEnable);
                    paramElements[k].childNodes[0].nodeValue = osdData.join('+');
                }
            }
            i += g_channelList.length-1;
        }
        else if(paramElements[i].getAttribute("name") == STR_SPOT_SPLIT_MODE)
        {
            ;
        }
        else if(paramElements[i].getAttribute("name") == STR_SPOT_DWELL_TIME)
        {
            ;
        }
    }
}

function BeginPositionSet(bTimeStamp, setChannel)
{
    g_bTimeStampPosSet = bTimeStamp;
    osd_position_set_pane.style.display = "";
    g_curSetChannel = setChannel;
    osd_x_pos.value = 0;
    osd_y_pos.value = 0;

    if(g_bTimeStampPosSet)
    {
        osd_position_set_label.innerHTML = timePosition_set_head;
        if(g_curSetChannel != -1)
        {
            osd_x_pos.value = g_timeStamp[g_curSetChannel].xPos;
            osd_y_pos.value = g_timeStamp[g_curSetChannel].yPos;
        }
    }
    else
    {
        osd_position_set_label.innerHTML = osdPosition_set_head;
        if(g_curSetChannel != -1)
        {   
            osd_x_pos.value = g_camNameOsd[g_curSetChannel].xPos;
            osd_y_pos.value = g_camNameOsd[g_curSetChannel].yPos;
        }
    }

    if(g_curSetChannel != -1)
    {
        osd_channel.innerText = channel_string + " " + (g_curSetChannel+1);
    }
    else
    {
        osd_channel.innerText = all_string + " " + channel_string;
    }

    Align();
    EdgeCtrl(div_config_index,72);
    location.href = "#record_osd_all_label";
}

function EndPositionSet(bSave)
{
    osd_position_set_pane.style.display = "none";
    Align();
    EdgeCtrl(div_config_index,72);
    
    if(!bSave)
    {
        return;
    }
    
    g_bChange = true;
    if(g_bTimeStampPosSet)
    {
        if(g_curSetChannel == -1)
        {
            for(var i = 0; i < g_channelList.length; i++)
            {
                g_timeStamp[i].xPos = parseInt(osd_x_pos.value,10);
                g_timeStamp[i].yPos = parseInt(osd_y_pos.value,10);
            }
        }
        else
        {
            g_timeStamp[g_curSetChannel].xPos = parseInt(osd_x_pos.value,10);
            g_timeStamp[g_curSetChannel].yPos = parseInt(osd_y_pos.value,10);
        }
    }
    else
    {
        if(g_curSetChannel == -1)
        {
            for(var i = 0; i < g_channelList.length; i++)
            {
                g_camNameOsd[i].xPos = parseInt(osd_x_pos.value,10);
                g_camNameOsd[i].yPos = parseInt(osd_y_pos.value,10);
            }
        }
        else
        {
            g_camNameOsd[g_curSetChannel].xPos = parseInt(osd_x_pos.value,10);
            g_camNameOsd[g_curSetChannel].yPos = parseInt(osd_y_pos.value,10);
        }
    }
}
