﻿// JScript 文件

var g_curInfoIndex = 0;
var g_eventLogPath = "";
var g_infoPath = "";

function EventInfo(channel, type, startTime, endTime)
{
    this.channel = channel;
    this.type = type;
    this.startTime = startTime;
    this.endTime = endTime;
}

function LogInfo(type, user, time, ip)
{
    this.type = type;
    this.user = user;
    this.time = time;
    this.ip = ip;
}

function GotoInfoPage()
{
    StopWait();
	if(g_mainMenuItem == 3)
	{
		HintSave(-1);
	}
	g_mainMenuItem = 5;
    selected(g_mainMenuItem);
    
	HideDIVs();
	div_main_menu.style.display		= "";
	div_info_index.style.display	= "";
	div_info_body.style.display	    = "";
	div_info.style.display          = "";
	
	g_lastNav = "";
	g_lastNavSec = "";

	if (g_xmlhttp == null)
    {
         return;
    }
    
    g_xmlhttp.open("get", "body_html/body_info_index.html", false);
    
    SafeHttpSend(g_xmlhttp, null);
    OnReceiveInfoIndex();
    g_curInfoIndex = 0;
    NavSelected(m21);
    GotoInfoBody('body_basic_info.html', 1);
}

function OnReceiveInfoIndex()
{
    if (g_xmlhttp.readyState != 4) 
    {
        return;
    }
    div_info_index.innerHTML = g_xmlhttp.responseText;
    ApplyXmlLang("info_index.xml");
    div_info_index.actualHeight = div_info_index.offsetHeight;
}

function GotoInfoBody(infoName, infoIndex)
{
	if(g_curInfoIndex == infoIndex)
	{
		return;
	}
	
	g_curInfoIndex = infoIndex;
	
	if (g_xmlhttp == null)
    {
         return;
    }

    g_xmlhttp.open("get", "body_html/" + infoName, false);

    SafeHttpSend(g_xmlhttp, null);
    OnReceiveInfoBody();
}

function OnReceiveInfoBody()
{
	var configData;
    if (g_xmlhttp.readyState != 4) 
    {
        return;
    }
    div_info_body.style.height = "";
    div_info_body.innerHTML = g_xmlhttp.responseText;
    OnFreshInfo();
    EdgeCtrl(div_info_index,72);
    
    //zld 2010/9/8
    if (document.getElementById("div_info_index").offsetHeight>=document.getElementById("div_info_body").offsetHeight) 
    {
        var div_info_height=document.getElementById("div_info_index").offsetHeight+6;
        document.getElementById("div_info").style.height=div_info_height+"px";
        
        var isIE = /msie/i.test(navigator.userAgent); 
        if (!isIE) 
        {
            var work_area_height = div_info_height+60;
            document.getElementById("work_area").style.height =work_area_height+"px";
        }
        else
        {
           // var work_area_height = div_info_height+40;
           // document.getElementById("work_area").style.height =work_area_height+"px";
        }
    }
    else
    {
        var div_info_height=document.getElementById("div_info_body").offsetHeight+6;
        document.getElementById("div_info").style.height=div_info_height+"px";
        
        var isIE = /msie/i.test(navigator.userAgent); 
        if (!isIE) 
        {
            var work_area_height = div_info_height+60;
            document.getElementById("work_area").style.height =work_area_height+"px";
        }
    }
}

function OnFreshInfo()
{
    //zld 2010/9/9
    var channel_index=document.getElementsByName("channel_index");
        
    InfoList.Instance().arrLogInfo = null;
    InfoList.Instance().curPage = 0;

    var curDate = new Date();
    curDate = curDate.getFullYear() + "-" + AlignTime(curDate.getMonth()+1) + "-" + AlignTime(curDate.getDate());

    if(g_curInfoIndex == 1)
    {
        ApplyXmlLang("info_basic.xml");
        QuerySystemInfo();
    }
    else if(g_curInfoIndex == 2)
    {
        if(!g_supportFunctions.IsSupportLogExport())
        {
            div_export_path.style.display = "none";
        }
        
        GenCheckGroup(id_event_channel,false, g_channelList,"channel_index");
        //GenCheckGroup_NoTdBorder(id_event_channel,false, g_channelList,"channel_index");
        
		var startDate = new DateTicker("event_start_dateticker");
		info_event_sdate_span.innerHTML = startDate;
		info_event_sdate_span.dateName = "event_start_dateticker";
		
		var endDate = new DateTicker("event_end_dateticker");
		info_event_edate_span.innerHTML = endDate;
		info_event_edate_span.dateName = "event_end_dateticker";
		
		var startTime = new DateBox("event_time", false, true);
		info_event_stime_span.innerHTML = startTime;
		info_event_stime_span.dateName = "event_time";
		
		var endTime = new DateBox("event_end_time", false, true);
		info_event_etime_span.innerHTML = endTime;
		info_event_etime_span.dateName = "event_end_time";
        
        for(var i =  0; i < channel_index.length; i++)
        {
            channel_index[i].checked = true;
        }
        UpdateCheckItems(id_event_channel);
        DateTicker.all[info_event_sdate_span.dateName].setValue(curDate);
        DateTicker.all[info_event_edate_span.dateName].setValue(curDate);
        DateBox.all[info_event_stime_span.dateName].setValue(new Array('00','00','00'));
        DateBox.all[info_event_etime_span.dateName].setValue(new Array('23','59','59'));
        
        info_event_list_page.innerHTML = "0/0";
        
        ApplyXmlLang("info_event.xml");
        
        export_path.value = g_eventLogPath;
		export_button.disabled = true;
    }
    else if(g_curInfoIndex == 3)
    {
        if(!g_supportFunctions.IsSupportLogExport())
        {
            div_export_path.style.display = "none";
        }
        g_calendarLogData.OnChangeMonth = function(curYear, curMonth)
        {
		    g_calendarLogData.dayStates = 0;
        }
//        g_calendarLogData.Create(id_log_cal);
		var startDate = new DateTicker("log_start_dateticker");
		info_log_sdate_span.innerHTML = startDate;
		info_log_sdate_span.dateName = "log_start_dateticker";
		
		var endDate = new DateTicker("log_end_dateticker");
		info_log_edate_span.innerHTML = endDate;
		info_log_edate_span.dateName = "log_end_dateticker";
		
		var startTime = new DateBox("log_time", false, true);
		info_log_stime_span.innerHTML = startTime;
		info_log_stime_span.dateName = "log_time";
		
		var endTime = new DateBox("log_end_time", false, true);
		info_log_etime_span.innerHTML = endTime;
		info_log_etime_span.dateName = "log_end_time";
		
        DateTicker.all[info_log_sdate_span.dateName].setValue(curDate);
        DateTicker.all[info_log_edate_span.dateName].setValue(curDate);
        DateBox.all[info_log_stime_span.dateName].setValue(new Array('00','00','00'));
        DateBox.all[info_log_etime_span.dateName].setValue(new Array('23','59','59'));
        
        info_log_list_page.innerHTML = "0/0";
        
        ApplyXmlLang("info_log.xml");
        
        export_button.disabled = true;
        
        export_path.value = g_infoPath;
    }
    else if(g_curInfoIndex == 4)
    {
        ApplyXmlLang("info_net.xml");
        QueryNeworkInfo();
    }
    else if(g_curInfoIndex == 5)
    {
        ApplyXmlLang("info_online.xml");
        QueryOnlineUser();
    }
}

function InfoIndexControl(obj,childIndex,infoName,infoIndex)
{
    
    if((childIndex != -1)&&($("info_secondNav"+childIndex).style.display == "block"))
    {
        $("info_secondNav"+childIndex).style.display="none";
        obj.style.height = "50px";
    }
    else
	{
       for(var i = 1; i<=2; i++)
       {
			$("info_secondNav"+i).style.display="none";
			$("li"+i).style.height = "50px";
       }
       if(childIndex != -1)
       {
           $("info_secondNav"+childIndex).style.display="block";
           obj.style.height = "90px";
           for(var i = 1; i<=2; i++)
           {
               if($("li"+i)!=obj)
               {
                  $("li"+i).style.height = "50px";
               }
           }
       }
	}
	GotoInfoBody(infoName, infoIndex);
}

/*******************************************************************************
*
*   这里请求信息数据，并更新到WEB页面上
*
*******************************************************************************/
function QuerySystemInfo()
{
    info_device_name.innerHTML = const_device_name;
    info_device_id.innerHTML = const_device_id;
    info_hw_ver.innerHTML = const_hardware_ver;
    info_mcu_ver.innerHTML = const_mcu_ver;
    info_kernel_ver.innerHTML = const_kernel_ver;
    info_firmware_ver.innerHTML = const_software_ver;
    info_launch_date.innerHTML = const_build_date;
}

/************************************************************************************************
*
*<request>
	<command name="alarm_event">
		<event_type>[M|S|L|C]+</event_type>
		<channel_bits>channelBits</channel_bits>
		<start_time>YY-mm-dd HH:MM:SS</start_time>
		<end_time>YY-mm-dd HH:MM:SS</end_time>
	</command>
*<response>
*
************************************************************************************************/
function SearchEventInfo()
{
    export_button.disabled = true;
    InfoList.Instance().curPage = 0;
    InfoList.Instance().arrLogInfo = null;
    var eventType = "";
    if(event_motion.checked)
    {
        eventType += "M";
    }
    if(event_sensor.checked)
    {
        eventType += "S";
    }
    if(event_vloss.checked)
    {
        eventType += "L";
    }
    var channelBits = 0;
    var j = 0;
    for(var row = 0; row < id_event_channel.rows.length; row++)
    {
        var channelBoxes = id_event_channel.rows[row].getElementsByTagName("input");
        for(var i = 1; i < channelBoxes.length; i++)
        {
            if(channelBoxes[i].type.toLowerCase() == "checkbox")
            {
                if(channelBoxes[i].checked)
                {
                    channelBits |= (1 << j);
                }
                j++;
            }
        }
    } 
       
    if((eventType == "") || (channelBits == 0))
    {
        UpdateEvent();
        return;
    }    
    
    var startDate = DateTicker.all[info_event_sdate_span.dateName].getValue();
    var endDate = DateTicker.all[info_event_edate_span.dateName].getValue();
    var startTime = DateBox.all[info_event_stime_span.dateName].getValue();
    var endTime = DateBox.all[info_event_etime_span.dateName].getValue();
    
    startTime = startDate+" "+startTime;
    endTime = endDate+" "+endTime;
   
    if(endTime <= startTime)
	{
		window.alert(etime_small_than_stime_tip);
		UpdateEvent();
		return;
	}
	 
    StartWait();
    var strFunction = "QueryAlarmEvent(\""+eventType+"\","+channelBits+",\""+startTime+"\",\""+endTime+"\")";
    setTimeout(strFunction, 500);
}

function QueryAlarmEvent(eventType, channelBits, startTime, endTime)
{    
    var strReq = '<request>\r\n';
    strReq += '<command name="'+STR_ALARM_EVENT+'">\r\n';
    strReq += '<'+STR_EVENT_TYPE+'>'+eventType+'</'+STR_EVENT_TYPE+'>\r\n';
    strReq += '<'+STR_CHANNEL_BITS+'>'+channelBits+'</'+STR_CHANNEL_BITS+'>\r\n';
    strReq += '<'+STR_START_TIME+'>'+startTime+'</'+STR_START_TIME+'>\r\n';
    strReq += '<'+STR_END_TIME+'>'+endTime+'</'+STR_END_TIME+'>\r\n';
    strReq += '</command>\r\n';
    strReq += '</request>\r\n';
    
    var strReply = WebClient.ExcuteCmd(strReq);
    if(strReply =="")
    {
        StopWait();
        return;
    }
  

    //zld 2010/8/18
  if (g_xmlDoc!=null)
    {
        delete g_xmlDoc;
        g_xmlDoc=null;
    }
    g_xmlDoc = FormatToXmlDOM(strReply);
    g_xmlDoc.async = false;
    //g_xmlDoc.loadXML(strReply);
    var cmdElements = g_xmlDoc.documentElement.childNodes;
    if(cmdElements.length > 0)
    {
        if(cmdElements[0].attributes.getNamedItem("name").nodeValue == STR_REPLY_NO_AUTH)
        {
            window.alert(str_no_auth);
            StopWait();
            return;
        }
        InfoList.Instance().arrLogInfo = new Array();
        var channels = cmdElements[0].getElementsByTagName(STR_CHANNEL);
        var types = cmdElements[0].getElementsByTagName(STR_EVENT_TYPE);
        var startTimes = cmdElements[0].getElementsByTagName(STR_START_TIME);
        var endTimes = cmdElements[0].getElementsByTagName(STR_END_TIME);
        
        for(var i = 0; i < channels.length; i++)
        {
            InfoList.Instance().arrLogInfo[i] = new EventInfo(channels[i].childNodes[0].nodeValue, 
                                         types[i].childNodes[0].nodeValue, 
                                         startTimes[i].childNodes[0].nodeValue, 
                                         endTimes[i].childNodes[0].nodeValue);
        }
        
        StopWait();
        UpdateEvent();
    }
}

/************************************************************************************************
*
*<request>
	<command name="operate_log">
		<log_type>log type mask</log_type>
		<start_time>YY-mm-dd HH:MM:SS</start_time>
		<end_time>YY-mm-dd HH:MM:SS</end_time>
	</command>
*<response>
*
************************************************************************************************/
function SearchLogInfo()
{
    export_button.disabled = true;
    InfoList.Instance().curPage = 0;
    InfoList.Instance().arrLogInfo = null;
    var logType = 0;
    var logTypeCheckBoxes = id_log_type.getElementsByTagName("input");
    for(var i = 0; i < logTypeCheckBoxes.length; i++)
    {
        if(logTypeCheckBoxes[i].type.toLowerCase() == "checkbox")
        {
            if(logTypeCheckBoxes[i].checked)
            {
                logType |= (0x01 << parseInt(logTypeCheckBoxes[i].value,10));
            }
        }
    }
    if(logType == 0)
    {
        UpdateLogs();
        return;
    }
    
    var startDate = DateTicker.all[info_log_sdate_span.dateName].getValue();
    var endDate = DateTicker.all[info_log_edate_span.dateName].getValue();
    var startTime = DateBox.all[info_log_stime_span.dateName].getValue();
    var endTime = DateBox.all[info_log_etime_span.dateName].getValue();
    
    startTime = startDate+" "+startTime;
    endTime = endDate+" "+endTime;
    
    if(endTime <= startTime)
	{
		window.alert(etime_small_than_stime_tip);
		UpdateLogs();
		return;
	}
    StartWait();
    var strFunction = "QueryOperateLog("+logType+",\""+startTime+"\",\""+endTime+"\")";
    setTimeout(strFunction, 500);
}

function QueryOperateLog(logType, startTime, endTime)
{    
    var strReq = '<request>\r\n';
    strReq += '<command name="'+STR_OPERATE_LOG+'">\r\n';
    strReq += '<'+STR_LOG_TYPE+'>'+logType+'</'+STR_LOG_TYPE+'>\r\n';
    strReq += '<'+STR_START_TIME+'>'+startTime+'</'+STR_START_TIME+'>\r\n';
    strReq += '<'+STR_END_TIME+'>'+endTime+'</'+STR_END_TIME+'>\r\n';
    strReq += '</command>\r\n';
    strReq += '</request>\r\n';
    
    var strReply = WebClient.ExcuteCmd(strReq);
    
    if(strReply == "")
    {
        StopWait();
        return;
    }
    

    //zld 2010/8/18
  if (g_xmlDoc!=null)
    {
        delete g_xmlDoc;
        g_xmlDoc=null;
    }
    g_xmlDoc = FormatToXmlDOM(strReply);
    g_xmlDoc.async = false;
    //g_xmlDoc.loadXML(strReply);
    var cmdElements = g_xmlDoc.documentElement.childNodes;
    if(cmdElements.length > 0)
    {
        if(cmdElements[0].attributes.getNamedItem("name").nodeValue == STR_REPLY_NO_AUTH)
        {
            window.alert(str_no_auth);
            StopWait();
            return;
        }
        InfoList.Instance().arrLogInfo = new Array();
        var types = cmdElements[0].getElementsByTagName(STR_LOG_TYPE);
        var userElems = cmdElements[0].getElementsByTagName(STR_USER_NAME);
        var timeElems = cmdElements[0].getElementsByTagName(STR_START_TIME);
        var ipElems = cmdElements[0].getElementsByTagName(STR_IP_ADDRESS);
        
        for(var i = 0; i < types.length; i++)
        {
            InfoList.Instance().arrLogInfo[i] = new LogInfo(types[i].childNodes[0].nodeValue, 
                                         userElems[i].childNodes[0].nodeValue, 
                                         timeElems[i].childNodes[0].nodeValue, 
                                         ipElems[i].childNodes[0].nodeValue);
        }
        StopWait();
        UpdateLogs();
    }
}

function QueryOnlineUser()
{
    var strReq = '<request>\r\n';
    strReq += '<command name="'+STR_ONLINE_USER+'">\r\n';
    strReq += '</command>\r\n';
    strReq += '</request>\r\n';
    
    var strReply = WebClient.ExcuteCmd(strReq);
    if(strReply == "")
	{
	    return false;
	}
	

    //zld 2010/8/18
  if (g_xmlDoc!=null)
    {
        delete g_xmlDoc;
        g_xmlDoc=null;
    }
    g_xmlDoc = FormatToXmlDOM(strReply);
    g_xmlDoc.async = false;
    //g_xmlDoc.loadXML(strReply);
    
    var cmdElements = g_xmlDoc.documentElement.childNodes;
    if(cmdElements.length > 0)
    {
        if(cmdElements[0].attributes.getNamedItem("name").nodeValue == STR_REPLY_NO_AUTH)
        {
            window.alert(str_no_auth);
            return;
        }
        
        var ipElems = cmdElements[0].getElementsByTagName(STR_IP_ADDRESS);
        var userElems = cmdElements[0].getElementsByTagName(STR_USER_NAME);
        var statusElems = cmdElements[0].getElementsByTagName(STR_CLIENT_STATUS);
        
        for(var i = 0; i < ipElems.length; i++)
        {
            online_user_table.rows[i+1].cells[0].innerText = userElems[i].childNodes[0].nodeValue;
            online_user_table.rows[i+1].cells[1].innerText = ipElems[i].childNodes[0].nodeValue;
            online_user_table.rows[i+1].cells[2].innerText = (statusElems[i].childNodes[0].nodeValue=1) ? str_online : "";
        }
    }
}

function QueryNeworkInfo()
{
    var strReq = '<request>\r\n';
    strReq += '<command name="'+STR_NETWORK_INFO+'">\r\n';
    strReq += '</command>\r\n';
    strReq += '</request>\r\n';
    
    var strReply = WebClient.ExcuteCmd(strReq);

    //zld 2010/8/18
  if (g_xmlDoc!=null)
    {
        delete g_xmlDoc;
        g_xmlDoc=null;
    }
    g_xmlDoc = FormatToXmlDOM(strReply);
    g_xmlDoc.async = false;
    //g_xmlDoc.loadXML(strReply);
    
    if(strReply == "")
    {
        return;
    }
    
    var cmdElements = g_xmlDoc.documentElement.childNodes;
    if(cmdElements.length > 0)
    {
        if(cmdElements[0].attributes.getNamedItem("name").nodeValue == STR_REPLY_NO_AUTH)
        {
            window.alert(str_no_auth);
            return;
        }
        
        var paramElements = cmdElements[0].getElementsByTagName(STR_NETWORK_STATUS);
        if(paramElements.length > 0)
        {
            var paramData = paramElements[0].childNodes[0].nodeValue;
            //bDHCP+bPPPOE+bDDNS+bWify+netStatus+httpPort+netPort+IP+Mask+gateWay+DNS1+DNS2+MAC
            //  0     1       2    3       4         5      6      7   8    9     10   11    12
            var networkInfos = paramData.split('+');
            network_info_table.rows[0].cells[1].innerText = networkInfos[5];
            network_info_table.rows[1].cells[1].innerText = networkInfos[6];
            network_info_table.rows[2].cells[1].innerText = networkInfos[7];
            network_info_table.rows[3].cells[1].innerText = networkInfos[8];
            network_info_table.rows[4].cells[1].innerText = networkInfos[9];
            network_info_table.rows[5].cells[1].innerText = networkInfos[10];
            network_info_table.rows[6].cells[1].innerText = networkInfos[11];
            if(networkInfos[1] != "0")
            {
                network_info_table.rows[7].cells[1].innerText = str_pppoe;
            }
            else
            {
                if(networkInfos[0] != "0")
                {
                    network_info_table.rows[7].cells[1].innerText = str_dynamic_ip;
                }
                else
                {
                    network_info_table.rows[7].cells[1].innerText = str_static_ip;
                }
            }
            if(networkInfos[3] != "0")
            {
                network_info_table.rows[7].cells[1].innerText = network_info_table.rows[7].cells[1].innerText+" + wifi";
            }
            network_info_table.rows[8].cells[1].innerText = ((networkInfos[4] == '0') ? str_disconnected : str_connect);
            network_info_table.rows[9].cells[1].innerText = str_disconnected;
            if(networkInfos[2] != "0")
            {
                network_info_table.rows[9].cells[1].innerText = str_connect;
            }
            network_info_table.rows[10].cells[1].innerText = networkInfos[12];
        }
    }
}

function UpdateLogs()
{
    var rows = log_info_table.rows;
    if((InfoList.Instance().arrLogInfo == null) || (InfoList.Instance().arrLogInfo.length == 0))
    {
        for(j = 1; j <= 20; j++)
        {
            rows[j].cells[0].innerText = " ";
            rows[j].cells[0].title = "";
            rows[j].cells[1].innerText = " ";
            rows[j].cells[2].innerText = " ";
            rows[j].cells[3].innerText = " ";
        }
        info_log_list_page.innerHTML = "0/0";
        window.alert(str_no_data_tip);
        return;
    }
    
    export_button.disabled = false;
    var j = 1;    
    for(var i = InfoList.Instance().curPage*20; i < InfoList.Instance().arrLogInfo.length; i++)
    {
        j = i - (InfoList.Instance().curPage * 20) + 1;
        if(j >= rows.length)
        {
            break;
        }
        var type = parseInt(InfoList.Instance().arrLogInfo[i].type, 16);
        rows[j].cells[0].innerText = g_arrLogType[type>>16][type&0xffff];
        rows[j].cells[0].title = rows[j].cells[0].innerText;
        rows[j].cells[1].innerText = InfoList.Instance().arrLogInfo[i].user;
        rows[j].cells[2].innerText = InfoList.Instance().arrLogInfo[i].time;
        rows[j].cells[3].innerText = InfoList.Instance().arrLogInfo[i].ip;
    }
    j = j+1;
    for(; j <= 20; j++)
    {
        rows[j].cells[0].innerText = " ";
        rows[j].cells[0].title = "";
        rows[j].cells[1].innerText = " ";
        rows[j].cells[2].innerText = " ";
        rows[j].cells[3].innerText = " ";
    }
    info_log_list_page.innerHTML = InfoList.Instance().curPage+1+"/"+Math.ceil(InfoList.Instance().arrLogInfo.length/20);
}

function UpdateEvent()
{
    var rows = event_info_table.rows;
    if((InfoList.Instance().arrLogInfo == null) || (InfoList.Instance().arrLogInfo.length == 0))
    {
        for(j = 1; j <= 20; j++)
        {
            rows[j].cells[0].innerText = " ";
            rows[j].cells[1].innerText = " ";
            rows[j].cells[2].innerText = " ";
            rows[j].cells[3].innerText = " ";
        }
        info_event_list_page.innerHTML = "0/0";
        window.alert(str_no_data_tip);
        return;
    }
    
    export_button.disabled = false;
    var j = 1;
    var rows = event_info_table.rows;
    for(var i = InfoList.Instance().curPage*20; i < InfoList.Instance().arrLogInfo.length; i++)
    {
        j = i - (InfoList.Instance().curPage * 20) + 1;
        if(j >= rows.length)
        {
            break;
        }
        rows[j].cells[0].innerText = parseInt(InfoList.Instance().arrLogInfo[i].channel,10)+1;
        var type = InfoList.Instance().arrLogInfo[i].type;
        if(type == 'L')
        {
            rows[j].cells[1].innerText = info_event_vloss_label.innerText;
        }
        else if(type == 'S')
        {
            rows[j].cells[1].innerText = info_event_sensor_label.innerText;
        }
        else if(type == 'M')
        {
            rows[j].cells[1].innerText = info_event_motion_label.innerText;
        }
        rows[j].cells[2].innerText = InfoList.Instance().arrLogInfo[i].startTime;
        rows[j].cells[3].innerText = InfoList.Instance().arrLogInfo[i].endTime;
    }
    j = j+1;
    for(; j <= 20; j++)
    {
        rows[j].cells[0].innerText = " ";
        rows[j].cells[1].innerText = " ";
        rows[j].cells[2].innerText = " ";
        rows[j].cells[3].innerText = " ";
    }
    info_event_list_page.innerHTML = InfoList.Instance().curPage+1+"/"+Math.ceil(InfoList.Instance().arrLogInfo.length/20);
}

function InfoList()
{
    this.curPage = 0;
    this.arrLogInfo = null;
}

InfoList.prototype = 
{
    UpdatePage:function()
    {
        if(g_curInfoIndex == 2) //alarm event
        {
            UpdateEvent();
        }
        else if(g_curInfoIndex == 3)        //logs
        {
            UpdateLogs();
        }
    },
    FirstPage:function ()
    {
        if((this.arrLogInfo == null) || (this.arrLogInfo.length == 0))
        {
            return;
        }
        this.curPage = 0;
        this.UpdatePage();
    },
    NextPage:function ()
    {
        if((this.arrLogInfo == null) || (this.arrLogInfo.length == 0))
        {
            return;
        }
        if((this.curPage+1) * 20 >= this.arrLogInfo.length)
        {
            return;
        }
        this.curPage++;
        this.UpdatePage();
    },
    PrevPage:function ()
    {
        if((this.arrLogInfo == null) || (this.arrLogInfo.length == 0))
        {
            return;
        }
        if(this.curPage > 0)
        {
            this.curPage--;
            this.UpdatePage();
        }
    },
    LastPage:function ()
    {
        if((this.arrLogInfo == null) || (this.arrLogInfo.length == 0))
        {
            return;
        }
        this.curPage = Math.ceil(this.arrLogInfo.length/20)-1;
        this.UpdatePage();
    }
}
InfoList.instance = null;
InfoList.Instance = function ()
{
    if(InfoList.instance == null)
    {
        InfoList.instance = new InfoList;
    }
    return InfoList.instance;
}

var g_arrLogTypeSys = new Array("", 
    LOG_TYPE_BOOT, 
    LOG_TYPE_SHUTDOWN, 
    LOG_TYPE_REBOOT, 
    LOG_TYPE_FORMAT_SUCC,
    LOG_TYPE_FORMAT_FAIL, 
    LOG_TYPE_UPGRADE_SUCC, 
    LOG_TYPE_UPGRADE_FAIL, 
    LOG_TYPE_CLEAR_ALARM, 
    LOG_TYPE_OPEN_ALARM,
    LOG_TYPE_MANUAL_START,
    LOG_TYPE_MANUAL_STOP, 
    LOG_TYPE_PTZ_ENTER, 
    LOG_TYPE_PTZ_CTRL, 
    LOG_TYPE_PTZ_EXIT, 
    LOG_TYPE_AUDIO_CH_CHANGE,
    LOG_TYPE_VOLUME_ADJUST, 
    LOG_TYPE_MUTE_ENABLE, 
    LOG_TYPE_MUTE_DISENABLE, 
    LOG_TYPE_DWELL_ENABLE, 
    LOG_TYPE_DWELL_DISENABLE,
    LOG_TYPE_LOG_IN, 
    LOG_TYPE_LOG_OFF, 
    LOG_TYPE_CHANGE_TIME,
    LOG_TYPE_MANUAL_SNAP_SUCC,
    LOG_TYPE_MANUAL_SNAP_FAIL);
 
var g_arrLogTypeCfg = new Array("", 
    LOG_TYPE_CHGE_VIDEO_FORMAT,	
    LOG_TYPE_CHGE_VGA_RESOLUTION,
	LOG_TYPE_CHGE_LANGUAGE,	
	LOG_TYPE_CHGE_NET_USER_NUM,	
	LOG_TYPE_CHGE_TIME_ZONE,
	LOG_TYPE_NTP_MANUAL, 
	LOG_TYPE_NTP_ON, 
	LOG_TYPE_NTP_OFF, 
	LOG_TYPE_CHGE_NTP_SERVER,
	LOG_TYPE_CHGE_DST,
	LOG_TYPE_PASSWD_ON,
	LOG_TYPE_PASSWD_OFF,
	LOG_TYPE_CHGE_CAM_NAME,
	LOG_TYPE_MODIFY_COLOR,
	LOG_TYPE_CHGE_HOST_MONITOR,
	LOG_TYPE_CHGE_SPOT,
	LOG_TYPE_CHGE_OSD,
	LOG_TYPE_CHGE_LOCAL_ENCODE,	
	LOG_TYPE_CHGE_REC_VIDEO_SWITCH,	
	LOG_TYPE_CHGE_REC_AUDIO_SWITCH,	
	LOG_TYPE_CHGE_REC_REDU_SWITCH, 
	LOG_TYPE_CHGE_REC_PRE_TIME, 
	LOG_TYPE_CHGE_REC_POST_TIME,
	LOG_TYPE_CHGE_REC_HOLD_TIME,
	LOG_TYPE_CHGE_SCH_SCHEDULE,	
	LOG_TYPE_CHGE_SCH_MOTION,
	LOG_TYPE_CHGE_SCH_ALARM, 
	LOG_TYPE_CHGE_SENSOR_SWITCH, 
	LOG_TYPE_CHGE_SENSOR_TYPE,
	LOG_TYPE_CHGE_SENSOR_TRIGGER, 
	LOG_TYPE_CHGE_SENSOR_SCH,
	LOG_TYPE_CHGE_MOTION_SWITCH,
	LOG_TYPE_CHGE_MOTION_SENS, 
	LOG_TYPE_CHGE_MOTION_AREA, 
	LOG_TYPE_CHGE_MOTION_TRIGGER,
	LOG_TYPE_CHGE_MOTION_SCH, 
	LOG_TYPE_CHGE_VL_TRIGGER,
	LOG_TYPE_CHGE_RELAY_SWITCH,	
	LOG_TYPE_CHGE_RELAY_SCH, 
	LOG_TYPE_BUZZER_ON, 
	LOG_TYPE_BUZZER_OFF,
	LOG_TYPE_CHGE_BUZZER_SCH,
	LOG_TYPE_CHGE_HTTP_PORT, 
	LOG_TYPE_CHGE_SER_PORT,
	LOG_TYPE_CHGE_IP,
	LOG_TYPE_DHCP_SUCC,
	LOG_TYPE_DHCP_FAIL,	
	LOG_TYPE_CHGE_PPPOE, 
	LOG_TYPE_CHGE_DDNS,
	LOG_TYPE_NET_STREAM_CFG,
	LOG_TYPE_CHGE_SERIAL,
	LOG_TYPE_PRESET_MODIFY,
	LOG_TYPE_CRUISE_MODIFY,
	LOG_TYPE_TRACK_MODIFY, 
	LOG_TYPE_USER_ADD,
	LOG_TYPE_USER_MODIFY,
	LOG_TYPE_USER_DELETE,
	LOG_TYPE_CHANGE_PASSWD,	
	LOG_TYPE_LOAD_DEFAULT,
	LOG_TYPE_IMPORT_CONFIG,
	LOG_TYPE_EXPORT_CONFIG,
	
	" ",//LOG_TYPE_CHGE_IMAGE_MASK,
	" ",//LOG_TYPE_RECYCLE_REC_ON,
	" ",//LOG_TYPE_RECYCLE_REC_OFF,
	" ",//LOG_TYPE_CHGE_DISK_ALARM,
	LOG_TYPE_CHGE_SEND_EMAIL,
	LOG_TYPE_CHGE_RECV_EMAIL,
	LOG_TYPE_CHGE_SNAP_SETTING);

var g_arrLogTypePlayback = new Array("", 
    LOG_TYPE_PLAYBACK_PLAY, 
    LOG_TYPE_PLAYBACK_RESUME,
    LOG_TYPE_PLAYBACK_PAUSE, 
    LOG_TYPE_PLAYBACK_FF, 
    LOG_TYPE_PLAYBACK_REW, 
    LOG_TYPE_PLAYBACK_STOP,
    
    " ",//LOG_TYPE_PLAYBACK_NEXT_SECTION,
	//LOG_TYPE_PLAYBACK_PREV_SECTION
	" ");

var g_arrLogTypeBackup = new Array("", 
    LOG_TYPE_BACKUP_START, 
    LOG_TYPE_BACKUP_COMPLETE, 
    LOG_TYPE_BACKUP_CANCEL, 
    LOG_TYPE_BACKUP_FAIL);

var g_arrLogTypeSearch = new Array("", 
    LOG_TYPE_SEARCH_TIME, 
    LOG_TYPE_SEARCH_EVENT, 
    LOG_TYPE_SEARCH_FILE_MAN, 
    LOG_TYPE_DELETE_FILE, 
    LOG_TYPE_LOCK_FILE, 
    LOG_TYPE_UNLOCK_FILE,
    LOG_TYPE_DELETE_PICTURE,
    LOG_TYPE_LOCK_PICTURE,
    LOG_TYPE_UNLOCK_PICTURE);

var g_arrLogTypeViewLog = new Array("", 
    LOG_TYPE_VIEW_SYSTEM, 
    LOG_TYPE_VIEW_EVENT, 
    LOG_TYPE_VIEW_LOG, 
    LOG_TYPE_VIEW_NETWORK, 
    LOG_TYPE_VIEW_ONLINE_USER, 
    LOG_TYPE_VIEW_EXPORT_LOG,
    LOG_TYPE_VIEW_EXPORT_EVENT);
    
var g_arrLogTypeException = new Array("", 
    LOG_TYPE_IP_CONFLICT, 
    LOG_TYPE_NETWORK_ERR, 
    LOG_TYPE_DDNS_ERR, 
    LOG_TYPE_DISK_IO_ERR, 
    LOG_TYPE_UNKNOWN_OFF,
    LOG_TYPE_UNKNOWN_ERR, 
    LOG_TYPE_ERR_9A9A9A9A,
	LOG_TYPE_ERR_9A000001,
	LOG_TYPE_ERR_9A000002,
    LOG_TYE_DISK_WARNING);

var g_arrLogType = new Array();
g_arrLogType[0x1] = g_arrLogTypeSys;
g_arrLogType[0x2] = g_arrLogTypeCfg;
g_arrLogType[0x4] = g_arrLogTypePlayback;
g_arrLogType[0x8] = g_arrLogTypeBackup;
g_arrLogType[0x10] = g_arrLogTypeSearch;
g_arrLogType[0x20] = g_arrLogTypeViewLog;
g_arrLogType[0x40] = g_arrLogTypeException;

function EventExport()
{
    if(export_path.value == "")
    {
        return;
    }
    if((InfoList.Instance().arrLogInfo == null) || (InfoList.Instance().arrLogInfo.length == 0))
    {
        return;
    }
    
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_LM_EVENT_STRING+"\">\r\n";
    strRequest += "<item id=\"1\">" + info_event_motion_label.innerText + "</item>\r\n";
    strRequest += "<item id=\"2\">" + info_event_sensor_label.innerText + "</item>\r\n";
    strRequest += "<item id=\"4\">" + info_event_vloss_label.innerText + "</item>\r\n";
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    WebClient.ExcuteLocalCmd(strRequest);

    strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_LM_EVENT_EXPORT+"\">\r\n";
    strRequest += "<"+STR_PATH+">" + export_path.value + "</"+STR_PATH+">\r\n";
    strRequest += "<"+STR_TITLE+">" + event_tabel_label.innerText + "</"+STR_TITLE+">\r\n";
    strRequest += "<"+STR_TITLE+">" + info_event_channel_label.innerText + "</"+STR_TITLE+">\r\n";
    strRequest += "<"+STR_TITLE+">" + info_event_type_label.innerText + "</"+STR_TITLE+">\r\n";
    strRequest += "<"+STR_TITLE+">" + info_event_starttime_label.innerText + "</"+STR_TITLE+">\r\n";
    strRequest += "<"+STR_TITLE+">" + info_event_endtime_label.innerText + "</"+STR_TITLE+">\r\n";
    
    //zld 2010/8/28 
    strRequest += "<"+STR_TIP+">" + info_event_first.title + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + info_event_previous.title + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + info_event_next.title + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + info_event_end.title + "</"+STR_TIP+">\r\n";
    
//    strRequest += "<"+STR_TIP+">" + info_event_first.alt + "</"+STR_TIP+">\r\n";
//    strRequest += "<"+STR_TIP+">" + info_event_previous.alt + "</"+STR_TIP+">\r\n";
//    strRequest += "<"+STR_TIP+">" + info_event_next.alt + "</"+STR_TIP+">\r\n";
//    strRequest += "<"+STR_TIP+">" + info_event_end.alt + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + str_records + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + str_is_the_last_tip + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + str_is_the_first_tip + "</"+STR_TIP+">\r\n";
    
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    WebClient.ExcuteLocalCmd(strRequest);
    window.alert(str_export_finish);
}

function LogExport()
{
    if(export_path.value == "")
    {
        return;
    }
    if((InfoList.Instance().arrLogInfo == null) || (InfoList.Instance().arrLogInfo.length == 0))
    {
        return;
    }
    
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_LM_LOG_STRING+"\">\r\n";
    for(var i = 0; i <= 0x40; i++)
    {
        if(g_arrLogType[i] != null)
        {
            for(var j = 1; j < g_arrLogType[i].length; j++)
            {
                strRequest += "<item id=\""+((i << 16) + j)+"\">" + g_arrLogType[i][j] + "</item>\r\n";
            }
        }
    }
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    WebClient.ExcuteLocalCmd(strRequest);
    
    strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_LM_LOG_EXPORT+"\">\r\n";
    strRequest += "<"+STR_PATH+">" + export_path.value + "</"+STR_PATH+">\r\n";
    strRequest += "<"+STR_TITLE+">" + log_tabel_label.innerText + "</"+STR_TITLE+">\r\n";
    strRequest += "<"+STR_TITLE+">" + info_log_type_label.innerText + "</"+STR_TITLE+">\r\n";
    strRequest += "<"+STR_TITLE+">" + info_log_username_label.innerText + "</"+STR_TITLE+">\r\n";
    strRequest += "<"+STR_TITLE+">" + info_log_time_label.innerText + "</"+STR_TITLE+">\r\n";
    strRequest += "<"+STR_TITLE+">" + info_log_ip_label.innerText + "</"+STR_TITLE+">\r\n";
    
    //zld 2010/8/28 
    strRequest += "<"+STR_TIP+">" + info_log_first.title + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + info_log_previous.title + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + info_log_next.title + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + info_log_end.title + "</"+STR_TIP+">\r\n";
    
//    strRequest += "<"+STR_TIP+">" + info_log_first.alt + "</"+STR_TIP+">\r\n";
//    strRequest += "<"+STR_TIP+">" + info_log_previous.alt + "</"+STR_TIP+">\r\n";
//    strRequest += "<"+STR_TIP+">" + info_log_next.alt + "</"+STR_TIP+">\r\n";
//    strRequest += "<"+STR_TIP+">" + info_log_end.alt + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + str_records + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + str_is_the_last_tip + "</"+STR_TIP+">\r\n";
    strRequest += "<"+STR_TIP+">" + str_is_the_first_tip + "</"+STR_TIP+">\r\n";
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    WebClient.ExcuteLocalCmd(strRequest);
    window.alert(str_export_finish);
}
