﻿// JScript 文件

var g_liveSelChannel = -1;
var g_queryHandle = 0;
var g_ptzSpeed = 4;
var g_preAction =  CreatePreAction();
var g_preBrushAction = CreatePreAction();
var g_preLampAction = CreatePreAction();
var g_ptzPresetList = null;
var g_ptzCruiseList = null;
var g_bCurChannelHide = 0;
var g_ptzCtrlXmlDoc = createXMLDoc();

function PTZErrors()
{
	this.PTZ_ERR_OK             = 0;
	this.PTZ_ERR_WRITE_COM      = 1;		//写串口失败
	this.PTZ_ERR_UF_PROTOCOL    = 2;		//没有找到协议集
	this.PTZ_ERR_CHNN_LOCK      = 3;		//通道被锁定
	this.PTZ_ERR_CHNN_UN_INTERRUPT = 4;	    //不能打断通道操作
	this.PTZ_ERR_CHNN_UN_SET    = 5;		//没有找到相关通道设置
	this.PTZ_ERR_CHNN_UN_ENABLE = 6;		//未启用通道
	this.PTZ_ERR_CHNN_WAITING   = 7;		//通道处于等待中
	this.PTZ_ERR_PRESET_DISABLE = 8;		//预置点未启用
	this.PTZ_ERR_OPERATE_FAIL   = 9;		//操作云台失败,
}

var g_PtzErrors = new PTZErrors();

function CreatePreAction()
{
    var preAction = new Array();
    for(var k = 0; k < g_channelList.length; k++)
    {
        preAction[k] = STR_PTZ_STOP_MOVE;
    }
    return preAction;
}

function doClick(linkId)
{
    var fireOnThis = document.getElementById(linkId);
    if(document.createEvent)
    {
        var evObj = document.createEvent('MouseEvents');
        evObj.initEvent('click', true, false);
        fireOnThis.dispatchEvent(evObj);
    }
    else if(document.createEventObject)
    {
//        fireOnThis.fireEvent('onmousemove');
        var evt = document.createEventObject();
//         evt.button = 2;
        evt.type = 'onmouseover';
        evt.toElement = fireOnThis;
        evt.srcElement = fireOnThis;
        var rect = fireOnThis.getBoundingClientRect();
        evt.offsetX = (rect.right+rect.left)/2;
        evt.offsetY = (rect.bottom-rect.top)/2;
        fireOnThis.fireEvent('onmouseover', evt);

    }
}


function GotoLivePage()
{
    if(g_mainMenuItem == 3)
    {
	    HintSave(-1);
    }
	
	g_mainMenuItem = 0;
    selected(g_mainMenuItem);
	HideDIVs();
	//zld 2010/10/14
	var isIE = /msie/i.test(navigator.userAgent); 
    if (isIE)
    {
        document.getElementById("ocx_alt_label").style.display = "";
    }
	
	document.getElementById("div_main_menu").style.display = "";
	document.getElementById("div_ocx").style.display = "";
	WebClient.style.display = "";
	
	g_xmlhttp.open("get", "body_html/body_live.html", false);
// 	g_xmlhttp.onreadystatechange = OnRecvLivePage;
	SafeHttpSend(g_xmlhttp, null);
	OnRecvLivePage();
}

function OnRecvLivePage()
{
    if(g_xmlhttp.readyState == 4)
	{
		document.getElementById("div_live").innerHTML = g_xmlhttp.responseText;
		ApplyXmlLang("live.xml");
		
		if(!g_supportFunctions.IsSupportPTZ())
		{
		    live2.style.display = "none";
		    div_live1.style.height = parseInt(div_live1.style.height)+35+"px";
		    div_live3.style.height = parseInt(div_live3.style.height)+35+"px";
		}
		
		//zld 2010/10/28
		var isIE = /msie/i.test(navigator.userAgent);
		if (isIE) 
		{
		    g_xmlhttp.open("get", "script/ctrl_slider.js", false);
		    SafeHttpSend(g_xmlhttp, null);
		}
		
// 	    g_xmlhttp.onreadystatechange = function ()
	    {
	        if(g_xmlhttp.readyState != 4)
	        {
	            return;
	        }
	        if (isIE)
	        {
	            DynAppendJS("ctrl_slider_js", g_xmlhttp.responseText);
	        }
	        
	        var div_bright=document.getElementById("div_bright");
	        var bright_bk=document.getElementById("bright_bk");
	        var bright_thumb=document.getElementById("bright_thumb");
	        var bright_tip=document.getElementById("bright_tip");
	        var div_contrast=document.getElementById("div_contrast");
	        var contrast_bk=document.getElementById("contrast_bk");
	        var contrast_thumb=document.getElementById("contrast_thumb");
	        var contrast_tip=document.getElementById("contrast_tip");
	        var div_saturation=document.getElementById("div_saturation");
	        var saturation_bk=document.getElementById("saturation_bk");
	        var saturation_thumb=document.getElementById("saturation_thumb");
	        var saturation_tip=document.getElementById("saturation_tip");
	        var div_hue=document.getElementById("div_hue");
	        
	        var hue_bk=document.getElementById("hue_bk");
	        var hue_thumb=document.getElementById("hue_thumb");
	        var hue_tip=document.getElementById("hue_tip");
	        var div_speed=document.getElementById("div_speed");
	        var speed_bk=document.getElementById("speed_bk");
	        var speed_thumb=document.getElementById("speed_thumb");
	        var speed_tip=document.getElementById("speed_tip");
	        var first_stream_table=document.getElementById("first_stream_table");
	        var web_rec_table=document.getElementById("web_rec_table");
	        var live3=document.getElementById("live3");
            
	        
	        CreateSlider(div_bright, bright_bk, bright_thumb, bright_tip, 0, 255, SetVideoColor);		
		    CreateSlider(div_contrast, contrast_bk, contrast_thumb, contrast_tip, 0, 255, SetVideoColor);
		    CreateSlider(div_saturation, saturation_bk, saturation_thumb, saturation_tip, 0, 255, SetVideoColor);
		    CreateSlider(div_hue, hue_bk, hue_thumb, hue_tip, 0, 255, SetVideoColor);
		    
		    SetSliderPos(bright_bk, bright_thumb, 128);
		    SetSliderPos(contrast_bk, contrast_thumb, 128);
		    SetSliderPos(saturation_bk, saturation_thumb, 128);
		    SetSliderPos(hue_bk, hue_thumb, 128);
		    
		    CreateSlider(div_speed, speed_bk, speed_thumb, speed_tip, 1, 8);
		    SetSliderPos(speed_bk, speed_thumb, g_ptzSpeed);

		    g_ptzPresetList = new Array(g_channelList.length);
            g_ptzCruiseList = new Array(g_channelList.length);
		    
		     
            if (isIE)
            {
		        FillPresetAndCruiseList();
		    }
		    else
		    {
		        GetPresetAndCruiseList();
		    }
            g_liveSelChannel = -1;
		    WebClient.SetVisible(1);
		    RecMouseout();
		    if (isIE)
            {
		        FreshPtzState();
		        FreshPtzBrushLampState();
		    }
		    liveNavCtrl(live3);
		    GenLiveTable(first_stream_table);
            GenLiveTable(web_rec_table);

            OnTimer();
            
            if(!const_support_talkback)
            {
                document.getElementById("start_talk").style.display = "none";
            }
            
            if(g_bTalking)
            {
                document.getElementById("start_talk").style.display = "none";
                document.getElementById("stop_talk").style.display = "";
            }
            
            if(g_bUseLogo)
            {
                logo_img_div.innerHTML = "<img style=\"cursor:auto;\" src = \"logo/logo.png\" alt = \"\"/>";
            }
            //zld 201010/13
	        //非IE下暂不支持对讲放功能
            var IE = /msie/i.test(navigator.userAgent);
            if (!IE)
            {
                document.getElementById("start_talk").style.display = "none";
                document.getElementById("stop_talk").style.display = "none";
            } 
	    }		
	
	    //zld 2010/8/27
	    //非IE下暂不支持本地录像和本地录像播放功能
	    
        var IE = /msie/i.test(navigator.userAgent);
        if (!IE) 
        {
            document.getElementById("rec_status_label").style.display="none";
            document.getElementById("web_rec_table").style.display="none";
            document.getElementById("filmclip_img").style.display="none";
            document.getElementById("clipplay_img").style.display="none"; 
        }
        
        document.getElementById("div_live").style.height = "";
	    document.getElementById("div_live").style.display = "";
	    //需要通过offsetHeight动态得到元素的实际高度时，就不能静待设置该元素的height，
	    //否则当实际高度>静待设置height时，offsetHeight的值=height，而不是实际的高度。
	    var height1= document.getElementById("div_live").offsetHeight;
	    var div_ocx_left= document.getElementById("div_main_menu").offsetLeft+5;
	    document.getElementById("div_ocx").style.left = div_ocx_left+"px";
	    var div_ocx_top= document.getElementById("div_main_menu").offsetTop+document.getElementById("div_main_menu").offsetHeight;
	    document.getElementById("div_ocx").style.top = div_ocx_top+"px";
	    document.getElementById("div_ocx").style.width = "770px";
	    var div_ocx_height= document.getElementById("div_live").offsetHeight-5;
	    document.getElementById("div_ocx").style.height = "";
	    //document.getElementById("div_ocx").style.height = div_ocx_height+"px";
	    //zld 2010/9/11
	    if (IE) 
	    {
	        document.getElementById("div_ocx").style.height ="595px";
	        document.getElementById("div_live").style.height ="600px";
	        WebClient.style.height ="590px";
            WebClient.style.width ="770px";
            
	    }
	    else
	    {
	        document.getElementById("div_ocx").style.height ="630px";
	        document.getElementById("div_live").style.height ="640px";
	        WebClient.style.height ="630px";
            WebClient.style.width ="770px";
            
            document.getElementById("work_area").style.height ="670px";
            document.getElementById("work_area").style.width ="980px";
            
	    }
	}
}

function FreshPtzState()
{
    var ptz_track=document.getElementById("ptz_track");
    var ptz_auto_scan=document.getElementById("ptz_auto_scan");
 
    ptz_track.src = "res/startCruise1.jpg";
    ptz_auto_scan.src = "res/startScan1.jpg";
    
    if(g_preAction[g_liveSelChannel] == STR_PTZ_START_TRACK)
    {
        ptz_track.src = "res/startCruise2.jpg";
    }
    if(g_preAction[g_liveSelChannel] == STR_PTZ_START_AUTOSCAN)
    {
        ptz_auto_scan.src = "res/startScan2.jpg";
    }
}

function FreshPtzBrushLampState()
{
    var ptz_brush = document.getElementById("ptz_brush");
    var ptz_lamp = document.getElementById("ptz_lamp");
    var ptz_brush_on = document.getElementById("ptz_brush_on");
    var ptz_lamp_on = document.getElementById("ptz_lamp_on");
    
    ptz_brush.style.display = "";
    ptz_brush_on.style.display = "none";
    
    ptz_lamp.style.display = "";
    ptz_lamp_on.style.display = "none";
    
    if (g_preLampAction[g_liveSelChannel] == STR_PTZ_AUXILIARY_LAMP) 
    {
        ptz_lamp.style.display = "none";
        ptz_lamp_on.style.display = "";
    }
    if (g_preLampAction[g_liveSelChannel] == STR_PTZ_STOP_LAMP) 
    {
        ptz_lamp.style.display = "";
        ptz_lamp_on.style.display = "none";
    }
    if (g_preBrushAction[g_liveSelChannel] == STR_PTZ_AUXILIARY_BRUSH) 
    {
        ptz_brush.style.display = "none";
        ptz_brush_on.style.display = "";
    }
    if (g_preBrushAction[g_liveSelChannel] == STR_PTZ_STOP_BRUSH) 
    {
        ptz_brush.style.display = "";
        ptz_brush_on.style.display = "none";
    }
}

function GetPresetAndCruiseList()
{
    SetNofityCallback(FillPresetAndCruiseList_Asyn);
    var xmlConfigReq = CreateConfigReqXml(ptz_advance_array);
    var xmlConfigReply = WebClient.ExcuteCmdAsyn(xmlConfigReq);
    if(xmlConfigReply != "") 
	{
	    FillPresetAndCruiseList_Asyn(xmlConfigReply);
	}
}

function FillPresetAndCruiseList_Asyn(xmlConfigReply)
{
    if(xmlConfigReply == "")
	{
	    return;
	}

    if (g_xmlDoc!=null)
    {
        delete g_xmlDoc;
        g_xmlDoc=null;
    }
    g_xmlDoc = FormatToXmlDOM(xmlConfigReply);
	g_xmlDoc.async = false;
	
	var xmlElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	
	for (i = 0; i < xmlElements.length; i++)
    {
		if (STR_PTZ_PRESET_INFO == xmlElements[i].attributes.getNamedItem("name").nodeValue)
		{
			var index = xmlElements[i].attributes.getNamedItem("index").nodeValue;
			g_ptzPresetList[index] = new Array();
			g_ptzPresetList[index][0] = new CSelectOptionInfo(str_select, -1);
			if(xmlElements[i].childNodes[0] == null)
			{
			    continue;
			}
			var presetDataInfo = xmlElements[i].childNodes[0].nodeValue;
			var curIndex = 0;
		
			while(presetDataInfo.length > 0)
			{
			    //index+bEnable+nameLen:presetName
			    var pIndex = parseInt(presetDataInfo,10);//获得预置点的INDEX
			    var pDataIndex = presetDataInfo.indexOf("+");//获得第一个+的索引
			    presetDataInfo = presetDataInfo.substr(pDataIndex+1);
			    var bEnable = parseInt(presetDataInfo,10);
			    pDataIndex = presetDataInfo.indexOf("+");//获得第2个+的索引
			    presetDataInfo = presetDataInfo.substr(pDataIndex+1);
			    var pLength = parseInt(presetDataInfo,10);//获得当前预置点名字的长度
			    var colonIndex =  presetDataInfo.indexOf(":");//获得信息中冒号的索引
			    var pName = presetDataInfo.SubStringOfBytes(colonIndex+1,pLength);//获得当前预置点的名字			    
			    presetDataInfo = presetDataInfo.substr(colonIndex+pName.length+2);
			    
			    if(bEnable != "0")
			    {
			        g_ptzPresetList[index][curIndex+1] = new CSelectOptionInfo(pName, pIndex);
			        curIndex++;
			    }
			}
		}
		if (STR_PTZ_CRUISE_INFO == xmlElements[i].attributes.getNamedItem("name").nodeValue)
		{
			var index = xmlElements[i].attributes.getNamedItem("index").nodeValue;
			g_ptzCruiseList[index] = new Array();
			g_ptzCruiseList[index][0] = new CSelectOptionInfo(str_select, -1);
			if(xmlElements[i].childNodes[0] == null)
			{
			    continue;
			}
			var cruiseDataInfo = xmlElements[i].childNodes[0].nodeValue;
			var curIndex = 0;
			
			while(cruiseDataInfo.length > 0)
			{
			    var markIndex = cruiseDataInfo.indexOf("(");//第一个括号的索引
			    var stringValue = cruiseDataInfo.substr(markIndex+1);//括号后的数据
			    
			    var cIndex = parseInt(stringValue,10);//巡航的索引
			    markIndex = stringValue.indexOf("+");//第一个加号的位置
			    stringValue = stringValue.substr(markIndex+1);//加号之后的数据
			    var cLength = parseInt(stringValue,10);//巡航线名字的长度
			    markIndex = stringValue.indexOf(":");
			    var cName = stringValue.SubStringOfBytes(markIndex+1,cLength);//获得当前巡航线的名字
			    stringValue = stringValue.substr(markIndex+1+cName.length);
			    markIndex = stringValue.indexOf(")");// 获取第一个反括号的位置
			    cruiseDataInfo = stringValue.substr(markIndex+1);			    
			    
			    g_ptzCruiseList[index][curIndex+1] = new CSelectOptionInfo(cName, cIndex);
			    
			    curIndex++;
			}
		}
	}

	if(g_liveSelChannel != -1)
	{
        //生成列表框之前先清空列表框的所有项
        var preset_list_live=document.getElementById("preset_list_live");
        var cruise_list_live=document.getElementById("cruise_list_live");
        preset_list_live.length=0;
        cruise_list_live.length=0;
        
	    GenSelectListEx(preset_list_live, g_ptzPresetList[g_liveSelChannel]);
	    GenSelectListEx(cruise_list_live, g_ptzCruiseList[g_liveSelChannel]);
	}
	
	FreshPtzState();
	FreshPtzBrushLampState();
}
function FillPresetAndCruiseList()
{
    //var xmlConfigReq = CreateConfigReqXml(ptz_advance_array);
	var xmlConfigReq =  "<request>\r\n";
	xmlConfigReq += "<command name=\"" + STR_REQUEST_CONFIG_GET + "\">\r\n";
	xmlConfigReq += "<parameter name=\"config_item\">" + STR_PTZ_PRESET_INFO + "</parameter>\r\n";
	 xmlConfigReq += "<parameter name=\"config_item\">" + STR_PTZ_CRUISE_INFO + "</parameter>\r\n";
	xmlConfigReq += "</command>\r\n";
	xmlConfigReq += "</request>\r\n";
	
		
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return;
	}
 	//window.alert(xmlConfigReply);
	//zld 2010/9/15
	//xmlConfigReply = DealXmlStr(xmlConfigReply);
	//zld 2010/8/18
    if (g_xmlDoc!=null)
    {
        delete g_xmlDoc;
        g_xmlDoc=null;
    }
    g_xmlDoc = FormatToXmlDOM(xmlConfigReply);
	g_xmlDoc.async = false;
	//g_xmlDoc.loadXML(xmlConfigReply);
	
	var xmlElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	
	for (i = 0; i < xmlElements.length; i++)
    {
		if (STR_PTZ_PRESET_INFO == xmlElements[i].attributes.getNamedItem("name").nodeValue)
		{
			var index = xmlElements[i].attributes.getNamedItem("index").nodeValue;
			g_ptzPresetList[index] = new Array();
			g_ptzPresetList[index][0] = new CSelectOptionInfo(str_select, -1);
			if(xmlElements[i].childNodes[0] == null)
			{
			    continue;
			}
			var presetDataInfo = xmlElements[i].childNodes[0].nodeValue;
			var curIndex = 0;
		
			while(presetDataInfo.length > 0)
			{
			    //index+bEnable+nameLen:presetName
			    var pIndex = parseInt(presetDataInfo,10);//获得预置点的INDEX
			    var pDataIndex = presetDataInfo.indexOf("+");//获得第一个+的索引
			    presetDataInfo = presetDataInfo.substr(pDataIndex+1);
			    var bEnable = parseInt(presetDataInfo,10);
			    pDataIndex = presetDataInfo.indexOf("+");//获得第2个+的索引
			    presetDataInfo = presetDataInfo.substr(pDataIndex+1);
			    var pLength = parseInt(presetDataInfo,10);//获得当前预置点名字的长度
			    var colonIndex =  presetDataInfo.indexOf(":");//获得信息中冒号的索引
			    var pName = presetDataInfo.SubStringOfBytes(colonIndex+1,pLength);//获得当前预置点的名字			    
			    presetDataInfo = presetDataInfo.substr(colonIndex+pName.length+2);
			    
			    if(bEnable != "0")
			    {
			        g_ptzPresetList[index][curIndex+1] = new CSelectOptionInfo(pName, pIndex);
			        curIndex++;
			    }
			}
		}
		if (STR_PTZ_CRUISE_INFO == xmlElements[i].attributes.getNamedItem("name").nodeValue)
		{
			var index = xmlElements[i].attributes.getNamedItem("index").nodeValue;
			g_ptzCruiseList[index] = new Array();
			g_ptzCruiseList[index][0] = new CSelectOptionInfo(str_select, -1);
			if(xmlElements[i].childNodes[0] == null)
			{
			    continue;
			}
			var cruiseDataInfo = xmlElements[i].childNodes[0].nodeValue;
			var curIndex = 0;
			
			while(cruiseDataInfo.length > 0)
			{
			    var markIndex = cruiseDataInfo.indexOf("(");//第一个括号的索引
			    var stringValue = cruiseDataInfo.substr(markIndex+1);//括号后的数据
			    
			    var cIndex = parseInt(stringValue,10);//巡航的索引
			    markIndex = stringValue.indexOf("+");//第一个加号的位置
			    stringValue = stringValue.substr(markIndex+1);//加号之后的数据
			    var cLength = parseInt(stringValue,10);//巡航线名字的长度
			    markIndex = stringValue.indexOf(":");
			    var cName = stringValue.SubStringOfBytes(markIndex+1,cLength);//获得当前巡航线的名字
			    stringValue = stringValue.substr(markIndex+1+cName.length);
			    markIndex = stringValue.indexOf(")");// 获取第一个反括号的位置
			    cruiseDataInfo = stringValue.substr(markIndex+1);			    
			    
			    g_ptzCruiseList[index][curIndex+1] = new CSelectOptionInfo(cName, cIndex);
			    
			    curIndex++;
			}
		}
	}

	if(g_liveSelChannel != -1)
	{
	    //zld 2010/10/18
//        var len=preset_list_live.length;
//        var i=0;
//        while (i<len)
//        {
//            preset_list_live.remove(0);
//            i++;
//        }
//        
//        len=cruise_list_live.length;
//        i=0;
//        while (i<len)
//        {
//            cruise_list_live.remove(0);
//            i++;
//        }

        //生成列表框之前先清空列表框的所有项
        var preset_list_live=document.getElementById("preset_list_live");
        var cruise_list_live=document.getElementById("cruise_list_live");
        preset_list_live.length=0;
        cruise_list_live.length=0;
        
	    GenSelectListEx(preset_list_live, g_ptzPresetList[g_liveSelChannel]);
	    GenSelectListEx(cruise_list_live, g_ptzCruiseList[g_liveSelChannel]);
	}

}

//请求远程录像
function CreateReqManualRecXml()
{
	var xmlConfigReq =  "<request>\r\n";
	xmlConfigReq += "<command name=\"" + STR_REQUEST_MANUAL_REC + "\">\r\n";
	var channelBits = new Array(64);
	for(var i = 0; i < const_channel_num; i++)
	{
		channelBits[i] = '1';
	}
	for(i = const_channel_num; i < 64; i++)
	{
		channelBits[i] = '0';
	}
	xmlConfigReq += "<parameter name=\"" + STR_REC_CHANNELS + "\">" + channelBits.join('') + "</parameter>\r\n";
	xmlConfigReq += "</command>\r\n";
	xmlConfigReq += "</request>\r\n";
	
	return xmlConfigReq;
}

function PtzTrackmouseout()
{
    if(g_preAction[g_liveSelChannel] != STR_PTZ_START_TRACK)
    {
        ptz_track.src = "res/startCruise1.jpg";
    }
}

function PtzAutoScanmouseout()
{
    if(g_preAction[g_liveSelChannel] != STR_PTZ_START_AUTOSCAN)
    {
        ptz_auto_scan.src = "res/startScan1.jpg";
    }
}

function RunLampBrushCtrl(action)
{
    if(g_liveSelChannel == -1)
    {
        return false;
    }
    
    if (action == STR_PTZ_AUXILIARY_BRUSH) 
    {
//        ptz_brush.style.display = "none";
//        ptz_brush_on.style.display = "";
        
        g_preBrushAction[g_liveSelChannel] = STR_PTZ_AUXILIARY_BRUSH;
    }
    if (action == STR_PTZ_AUXILIARY_LAMP) 
    {
//        ptz_lamp.style.display = "none";
//        ptz_lamp_on.style.display = "";
        
        g_preLampAction[g_liveSelChannel] = STR_PTZ_AUXILIARY_LAMP;
    }
    if (action == STR_PTZ_STOP_LAMP) 
    {
//       ptz_lamp.style.display = "";
//       ptz_lamp_on.style.display = "none";
       
       g_preLampAction[g_liveSelChannel] = STR_PTZ_STOP_LAMP;
    }
    if (action == STR_PTZ_STOP_BRUSH) 
    {
//       ptz_brush.style.display = "";
//       ptz_brush_on.style.display = "none";
       
       g_preBrushAction[g_liveSelChannel] = STR_PTZ_STOP_BRUSH;
    }
    
    try
    {
        g_ptzSpeed = GetSliderPos(speed_bk, speed_thumb);
    }
    catch(e)
    {
        g_ptzSpeed = 0;
    }
    
    var strCmd = "<request>\r\n";
    strCmd += "<command name=\"" + STR_PTZ_CONTROL + "\">\r\n";
    strCmd += "<channel>" + g_liveSelChannel +"</channel>\r\n";
    strCmd += "<action>" + action + "</action>\r\n";
    strCmd += "<speed>" + g_ptzSpeed + "</speed>\r\n";
    
     strCmd += "</command>\r\n";
    strCmd += "</request>\r\n";
    //<DEL BEGIN>
    var strReply = WebClient.ExcuteCmd(strCmd);
    
    if(strReply != "")
    {
          if (g_ptzCtrlXmlDoc!=null) 
          {
              delete g_ptzCtrlXmlDoc;
              g_ptzCtrlXmlDoc=null;
          }
        //zld 2010/8/18
        g_ptzCtrlXmlDoc = FormatToXmlDOM(strReply);
        g_ptzCtrlXmlDoc.async = false;
        //g_ptzCtrlXmlDoc.loadXML(strReply);
        
        var cmdElement = g_ptzCtrlXmlDoc.documentElement.childNodes[0];
        if(cmdElement.attributes.getNamedItem("name").nodeValue == STR_REPLY_NO_AUTH)
        {
            window.alert(str_no_auth);
            return false;
        }
        else if(cmdElement.attributes.getNamedItem("name").nodeValue == STR_PTZ_CONTROL)
        {
            var errorCode = cmdElement.childNodes[0].childNodes[0].nodeValue;
            if(errorCode != g_PtzErrors.PTZ_ERR_OK)
            {
                if(g_PtzErrors.PTZ_ERR_OPERATE_FAIL == errorCode)
                {
                    window.alert(str_config_by_other);
                }
                else
                {
                    window.alert(str_ptz_control_failed);
                }
                return false;
            }
        }
    }
    
    if(g_mainMenuItem == 0) //现场
    {
        FreshPtzBrushLampState();
    }
    
}

function RunPTZCtrl(action, param)
{
    if(g_liveSelChannel == -1)
    {
        return false;
    }
    
    if(STR_PTZ_STOP_MOVE == action)
    {
        if((STR_PTZ_LEFT != g_preAction[g_liveSelChannel])
            && (STR_PTZ_RIGHT != g_preAction[g_liveSelChannel])
            && (STR_PTZ_UP != g_preAction[g_liveSelChannel])
            && (STR_PTZ_DOWN != g_preAction[g_liveSelChannel])
            && (STR_PTZ_LEFT_UP != g_preAction[g_liveSelChannel])
            && (STR_PTZ_LEFT_DOWN != g_preAction[g_liveSelChannel])
            && (STR_PTZ_RIGHT_UP != g_preAction[g_liveSelChannel])
            && (STR_PTZ_RIGHT_DOWN != g_preAction[g_liveSelChannel])
            && (STR_PTZ_FOCUS_NEAR != g_preAction[g_liveSelChannel])
            && (STR_PTZ_FOCUS_FAR != g_preAction[g_liveSelChannel])
            && (STR_PTZ_ZOOM_IN != g_preAction[g_liveSelChannel])
            && (STR_PTZ_ZOOM_OUT != g_preAction[g_liveSelChannel])
            && (STR_PTZ_IRIS_OPEN != g_preAction[g_liveSelChannel])
            && (STR_PTZ_IRIS_CLOSE != g_preAction[g_liveSelChannel]))
        {
            return false;
        }
    }
    
    if(g_preAction[g_liveSelChannel] == STR_PTZ_START_TRACK )
    {
        if(action == STR_PTZ_START_TRACK)
        {
            action = STR_PTZ_STOP_TRACK;
        }
    }
    if(g_preAction[g_liveSelChannel] == STR_PTZ_START_AUTOSCAN)
    {
        if(action == STR_PTZ_START_AUTOSCAN)
        {
            action = STR_PTZ_STOP_AUTOSCAN;
        }
    }
    
    try
    {
        g_ptzSpeed = GetSliderPos(speed_bk, speed_thumb);
    }
    catch(e)
    {
        g_ptzSpeed = 0;
    }
    
    var strCmd = "<request>\r\n";
    strCmd += "<command name=\"" + STR_PTZ_CONTROL + "\">\r\n";
    strCmd += "<channel>" + g_liveSelChannel +"</channel>\r\n";
    strCmd += "<action>" + action + "</action>\r\n";
    strCmd += "<speed>" + g_ptzSpeed + "</speed>\r\n";
    
    if(action == STR_PTZ_GO_PRESET)
    {
        if((param == "") || (param == "-1"))
        {
            return false;
        }
        strCmd += "<"+STR_PTZ_PRESET+">" + param + "</"+STR_PTZ_PRESET+">\r\n";
    }
    
    if(action == STR_PTZ_RUN_CRUISE)
    {
        if(param == "-1")
        {
            return false;
        }
        strCmd += "<"+STR_PTZ_CRUISE+">" + param + "</"+STR_PTZ_CRUISE+">\r\n";
    }
    
    strCmd += "</command>\r\n";
    strCmd += "</request>\r\n";
    //<DEL BEGIN>
    var strReply = WebClient.ExcuteCmd(strCmd);
    
    if(strReply != "")
    {
          if (g_ptzCtrlXmlDoc!=null) 
          {
              delete g_ptzCtrlXmlDoc;
              g_ptzCtrlXmlDoc=null;
          }
        //zld 2010/8/18
        g_ptzCtrlXmlDoc = FormatToXmlDOM(strReply);
        g_ptzCtrlXmlDoc.async = false;
        //g_ptzCtrlXmlDoc.loadXML(strReply);
        
        var cmdElement = g_ptzCtrlXmlDoc.documentElement.childNodes[0];
        if(cmdElement.attributes.getNamedItem("name").nodeValue == STR_REPLY_NO_AUTH)
        {
            window.alert(str_no_auth);
            return false;
        }
        else if(cmdElement.attributes.getNamedItem("name").nodeValue == STR_PTZ_CONTROL)
        {
            var errorCode = cmdElement.childNodes[0].childNodes[0].nodeValue;
            if(errorCode != g_PtzErrors.PTZ_ERR_OK)
            {
                if(g_PtzErrors.PTZ_ERR_OPERATE_FAIL == errorCode)
                {
                    window.alert(str_config_by_other);
                }
                else
                {
                    window.alert(str_ptz_control_failed);
                }
                return false;
            }
        }
    }
    
    g_preAction[g_liveSelChannel] = action;

    if(g_mainMenuItem == 0) //现场
    {
        FreshPtzState();
    }
    
    return true;
}

function GetVideoColor()
{
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_GET_COLOR+"\">\r\n";
    strRequest += "<channel>" + g_liveSelChannel +"</channel>\r\n";
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    var strReply = WebClient.ExcuteCmd(strRequest);
    
    if(strReply != "")
    {
        FlushVideoColor(strReply);
    }
}

function SetVideoColor()
{
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_SET_COLOR+"\">\r\n";
    strRequest += "<"+STR_CHANNEL+">" + g_liveSelChannel +"</"+STR_CHANNEL+">\r\n";
    
    var bright = GetSliderPos(bright_bk, bright_thumb);
	var contrast = GetSliderPos(contrast_bk, contrast_thumb);
	var saturation = GetSliderPos(saturation_bk, saturation_thumb);
	var hue = GetSliderPos(hue_bk, hue_thumb);
	var bSend = true;
	if ((contrast < 20) || ((bright*bright + saturation*8 + contrast*contrast*2) <10000))
	{
	    bSend = false;
	    return;
	}
	if (bSend)
	{
	strRequest += "<"+STR_BRIGHT+">" + bright +"</"+STR_BRIGHT+">\r\n";
	strRequest += "<"+STR_CONTRAST+">" + contrast +"</"+STR_CONTRAST+">\r\n";
	strRequest += "<"+STR_SATURATION+">" + saturation +"</"+STR_SATURATION+">\r\n";
	strRequest += "<"+STR_HUE+">" + hue +"</"+STR_HUE+">\r\n";
    
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    var strReply = WebClient.ExcuteCmd(strRequest);
    }
    if(strReply != "")
    {

        //zld 2010/8/18
        if (g_xmlDoc!=null)
        {
            delete g_xmlDoc;
            g_xmlDoc=null;
        }
        g_xmlDoc = FormatToXmlDOM(strReply);
        g_xmlDoc.async = false;
        //g_xmlDoc.loadXML(strReply);
        var cmdElements = g_xmlDoc.documentElement.childNodes;
        if(cmdElements[0].attributes.getNamedItem("name").nodeValue == STR_REPLY_NO_AUTH)
	    {
	        document.fireEvent('onmouseup');
	        g_bSliderDrag = false;
	        window.alert(str_no_auth);
	        return false;
	    }
    }
    
    //zld 2010/10/16
    SaveVideoColor();
    return true;
}

function SaveVideoColor()
{
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_SAVE_COLOR+"\">\r\n";
    strRequest += "<"+STR_CHANNEL+">" + g_liveSelChannel +"</"+STR_CHANNEL+">\r\n";
    
    var bright = GetSliderPos(bright_bk, bright_thumb);
	var contrast = GetSliderPos(contrast_bk, contrast_thumb);
	var saturation = GetSliderPos(saturation_bk, saturation_thumb);
	var hue = GetSliderPos(hue_bk, hue_thumb);
	
	strRequest += "<"+STR_BRIGHT+">" + bright +"</"+STR_BRIGHT+">\r\n";
	strRequest += "<"+STR_CONTRAST+">" + contrast +"</"+STR_CONTRAST+">\r\n";
	strRequest += "<"+STR_SATURATION+">" + saturation +"</"+STR_SATURATION+">\r\n";
	strRequest += "<"+STR_HUE+">" + hue +"</"+STR_HUE+">\r\n";
    
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    var strReply = WebClient.ExcuteCmd(strRequest);
    
    if(strReply != "")
    {

        //zld 2010/8/18
        if (g_xmlDoc!=null)
        {
            delete g_xmlDoc;
            g_xmlDoc=null;
        }
        g_xmlDoc = FormatToXmlDOM(strReply);
        g_xmlDoc.async = false;
        //g_xmlDoc.loadXML(strReply);
        var cmdElements = g_xmlDoc.documentElement.childNodes;
        if(cmdElements[0].attributes.getNamedItem("name").nodeValue == STR_REPLY_NO_AUTH)
	    {
	        window.alert(str_no_auth);
	    }
    }
}

function SetDefaultVideoColor()
{
//    var strRequest = "<request>\r\n";
//    strRequest += "<command name=\""+STR_COLOR_DEFAULT+"\">\r\n";
//    strRequest += "<channel>" + g_liveSelChannel +"</channel>\r\n";
//    strRequest += "</command>\r\n";
//    strRequest += "</request>\r\n";
//    
//    var strReply = WebClient.ExcuteCmd(strRequest);
//    if(strReply == "")
//    {
//        return;
//    }

//    if (g_xmlDoc!=null)
//    {
//        delete g_xmlDoc;
//        g_xmlDoc=null;
//    }
//    g_xmlDoc=FormatToXmlDOM(strReply);
//    g_xmlDoc.async = false;
//    //g_xmlDoc.loadXML(strReply);
//    var cmdElements = g_xmlDoc.documentElement.childNodes;
//    if(cmdElements[0].attributes.getNamedItem("name").nodeValue == STR_REPLY_NO_AUTH)
//    {
//        window.alert(str_no_auth);
//        return;
//    }
    
 //   FlushVideoColor(strReply);
    if(!(g_authority.authority & 0x100))    //没有配置权限
    {
        window.alert(str_no_auth);
        return false;
    }
    SetSliderPos(bright_bk, bright_thumb, parseInt(g_colorInfo.bright,10));
	SetSliderPos(contrast_bk, contrast_thumb, parseInt(g_colorInfo.contrast,10));
	SetSliderPos(saturation_bk, saturation_thumb, parseInt(g_colorInfo.saturation,10));
	SetSliderPos(hue_bk, hue_thumb, parseInt(g_colorInfo.hue,10));
	
	SetVideoColor();
	
	return true;
}

function FlushVideoColor(colorXml)
{
    if(colorXml == "")
    {
        return;
    }
    
    //zld 2010/8/18
    if (g_xmlDoc!=null)
    {
        delete g_xmlDoc;
        g_xmlDoc=null;
    }
    g_xmlDoc = FormatToXmlDOM(colorXml);
    g_xmlDoc.async = false;
    //g_xmlDoc.loadXML(colorXml);
    
    var cmdElement = g_xmlDoc.documentElement.childNodes[0];
    var bright = cmdElement.getElementsByTagName(STR_BRIGHT)[0].childNodes[0].nodeValue;
    var contrast = cmdElement.getElementsByTagName(STR_CONTRAST)[0].childNodes[0].nodeValue;
    var saturation = cmdElement.getElementsByTagName(STR_SATURATION)[0].childNodes[0].nodeValue;
    var hue = cmdElement.getElementsByTagName(STR_HUE)[0].childNodes[0].nodeValue;
    
    g_bCurChannelHide = cmdElement.getElementsByTagName(STR_HIDE_CHANNEL)[0].childNodes[0].nodeValue;
    
    SetSliderPos(bright_bk, bright_thumb, parseInt(bright,10));
	SetSliderPos(contrast_bk, contrast_thumb, parseInt(contrast,10));
	SetSliderPos(saturation_bk, saturation_thumb, parseInt(saturation,10));
	SetSliderPos(hue_bk, hue_thumb, parseInt(hue,10));
}

function RecMouseout()
{
    document.getElementById("filmclip_img").src='res/video_clip_normal.jpg';
}

function SnapPicture()
{
    var strCmd = "<request>\r\n";
    strCmd += "<command name=\"" + STR_LM_SNAP + "\">\r\n";    
    strCmd += "</command>\r\n";
    strCmd += "</request>\r\n";
    
    WebClient.ExcuteLocalCmd(strCmd);
}

function VideoClip()
{
    var strCmd = "<request>\r\n";
    strCmd += "<command name=\"" + STR_LM_RECORD + "\">\r\n";
    strCmd += "</command>\r\n";
    strCmd += "</request>\r\n";
    
    var strResult = WebClient.ExcuteLocalCmd(strCmd);
    
    var xmlDoc;// = createXMLDoc();
    //zld 2010/8/18
    xmlDoc = FormatToXmlDOM(strResult);
    xmlDoc.async = false;
    //xmlDoc.loadXML(strResult);
    var cmdElements = xmlDoc.documentElement.childNodes;
    var resultElement = cmdElements[0].childNodes[0];
    if(resultElement.childNodes[0].nodeValue == "0")
    {
        window.alert(str_local_record_failed);
    }
}

function PlayClip()
{
    var strCmd = "<request>\r\n";
    strCmd += "<command name=\"" + STR_LM_LPB + "\">\r\n";
    strCmd += "</command>\r\n";
    strCmd += "</request>\r\n";
    
    var strResult = WebClient.ExcuteLocalCmd(strCmd);
}

function GetCurSelChannel()
{
    var strCmd = "<request>\r\n";
    strCmd += "<command name=\"" + STR_LM_GET_LIVE_CHANNEL + "\">\r\n";
    strCmd += "</command>\r\n";
    strCmd += "</request>\r\n";
    
    var strReply = WebClient.ExcuteLocalCmd(strCmd);
    if(strReply != "")
    {
        //zld 2010/8/18
        if (g_xmlDoc!=null)
        {
            delete g_xmlDoc;
            g_xmlDoc=null;
        }
        g_xmlDoc = FormatToXmlDOM(strReply);
        g_xmlDoc.async = false;
        //g_xmlDoc.loadXML(strReply);
        var cmdElements = g_xmlDoc.documentElement.childNodes;
        if((cmdElements[0].childNodes.length != 0) && (cmdElements[0].childNodes[0].childNodes.length != 0))
        {
            if(g_liveSelChannel != parseInt(cmdElements[0].childNodes[0].childNodes[0].nodeValue,10))
            {
                g_liveSelChannel = parseInt(cmdElements[0].childNodes[0].childNodes[0].nodeValue,10);
                //zld 2010/10/18
//                var len=preset_list_live.length;
//                var i=0;
//                while (i<len)
//                {
//                    preset_list_live.remove(0);
//                    i++;
//                }
//                
//                len=cruise_list_live.length;
//                i=0;
//                while (i<len)
//                {
//                    cruise_list_live.remove(0);
//                    i++;
//                }
                
                //生成列表框之前先清空列表框的所有项
                var preset_list_live=document.getElementById("preset_list_live");
                var cruise_list_live=document.getElementById("cruise_list_live");
                preset_list_live.length=0;
                cruise_list_live.length=0;
                GenSelectListEx(preset_list_live, g_ptzPresetList[g_liveSelChannel]);
                GenSelectListEx(cruise_list_live, g_ptzCruiseList[g_liveSelChannel]);
                GetVideoColor();
                FreshPtzState();
                FreshPtzBrushLampState();
            }
        }
    }
}

function GetLiveInfo()
{
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_LM_GET_LIVE_INFO+"\">\r\n";
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    var strReply = WebClient.ExcuteLocalCmd(strRequest);
    if(strReply != "")
    {
        //zld 2010/8/18
        if (g_xmlDoc!=null)
        {
            delete g_xmlDoc;
            g_xmlDoc=null;
        }
        //strReply=DealXmlStr(strReply);
        g_xmlDoc = FormatToXmlDOM(strReply);
        
        g_xmlDoc.async = false;
        //g_xmlDoc.loadXML(strReply);
        var cmdElements = g_xmlDoc.documentElement.childNodes;
        if((cmdElements[0].childNodes.length != 0) && (cmdElements[0].childNodes[0].childNodes.length != 0))
        {
            var liveTime = cmdElements[0].getElementsByTagName(STR_CLIENT_LIVE_TIME)[0];
            var masterStream = cmdElements[0].getElementsByTagName(STR_MASTER_STREAM_CH)[0];
            var secondStream = cmdElements[0].getElementsByTagName(STR_SECOND_STREAM_CH)[0];
            var recordChannel = cmdElements[0].getElementsByTagName(STR_CLIENT_RECORD_CH)[0];
            liveTime = liveTime.childNodes[0].nodeValue;
            masterStream = parseInt(masterStream.childNodes[0].nodeValue, 16);
            secondStream = parseInt(secondStream.childNodes[0].nodeValue, 16);
            recordChannel = parseInt(recordChannel.childNodes[0].nodeValue, 16);
            
            //zld 2010/9/17
            var streamMark_rows =document.getElementById("first_stream_table").rows;
            
            for(var i=0;i<streamMark_rows.length;i++)
            {
              var streamMark_cells =document.getElementById("first_stream_table").rows[i].cells;
              for(var channel = 0; channel < streamMark_cells.length; channel++)
              {
                 streamMark_cells[channel].style.backgroundColor="";
                 streamMark_cells[channel].style.color=live_status_color;
                
                 if(masterStream & (0x01 << (streamMark_cells.length*i+channel)))
                 {
                    streamMark_cells[channel].style.backgroundColor=live_master_bgcolor;
                    streamMark_cells[channel].style.color=live_status_onfocus_color;
                 }
                 if(secondStream & (0x01 << (streamMark_cells.length*i+channel)))
                 {
                    streamMark_cells[channel].style.backgroundColor = live_sub_bgcolor;
                    streamMark_cells[channel].style.color=live_status_onfocus_color;
                 }           
             }
           }

          var recordMark_rows =document.getElementById("web_rec_table").rows;
        
          for(var i=0;i<streamMark_rows.length;i++)
          {
            var recordMark_cells =document.getElementById("web_rec_table").rows[i].cells;
            for(var channel = 0; channel < streamMark_cells.length; channel++)
            {
                recordMark_cells[channel].style.backgroundColor="";
                recordMark_cells[channel].style.color=live_status_color;
                if(recordChannel & (0x01 << (streamMark_cells.length*i+channel)))
                {
                    recordMark_cells[channel].style.backgroundColor = live_local_rec_bgcolor;
                    recordMark_cells[channel].style.color=live_status_onfocus_color;
                }           
            }
          }

        div_live_time.innerText = liveTime;
        }
        
    }
}

function OnTimer()
{
    if(g_mainMenuItem == 0)
    {
        if(div_live3.style.display == "none")
        {
            GetCurSelChannel();
        }
        
        GetLiveInfo();
        
        g_queryHandle = setTimeout("OnTimer()", 1000);
    }
    else
    {
        clearTimeout(g_queryHandle);
    }
}

function liveNavCtrl(obj)
{
    for(var i = 1; i < 4; i++)
    {
        document.getElementById("div_live"+i).style.display = "none";
    }
    objId = document.getElementById("div_"+obj.id);
    if(objId.style.display == "")
    {
        objId.style.display = "none";
    }
    else
    {
        objId.style.display = "";
    }
    
    //zld 2010/8/27
    if (document.getElementById("div_live").offsetHeight>0) 
    {
        var div_ocx_height= document.getElementById("div_live").offsetHeight-5;
	    document.getElementById("div_ocx").style.height = "";
	    //document.getElementById("div_ocx").style.height = div_ocx_height+"px";
	    //zld 2010/9/11
	    var IE = /msie/i.test(navigator.userAgent);
	    
	    if (IE) 
	    {
	        document.getElementById("div_ocx").style.height ="595px";
	        document.getElementById("div_live").style.height ="600px";
	    }
	    else
	    {
	        document.getElementById("div_live1").style.height ="470px";
	        document.getElementById("div_ocx").style.height ="635px";
	        document.getElementById("div_live").style.height ="640px";
	    }
    }
}

function OnTalk()
{
    if(!(g_authority.authority & 0x400))    //没有对讲权限
    {
        window.alert(str_no_auth);
        return false;
    }
    
    if(g_bTalking)
    {
        return;
    }
    
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_LM_START_TALK+"\">\r\n";
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    strReply = WebClient.ExcuteLocalCmd(strRequest);
    
    if(strReply == "")
    {
        return;
    }
        
    var talkXmlDoc;// = createXMLDoc();
    //zld 2010/8/18
    talkXmlDoc = FormatToXmlDOM(strReply);
    talkXmlDoc.async = false;
    //talkXmlDoc.loadXML(strReply);
    var cmdElements = talkXmlDoc.documentElement.childNodes;
    if((cmdElements.length > 0) && (cmdElements[0].getAttribute("name") == STR_LM_START_TALK_SUCC))
    {
        g_bTalking = true;
        start_talk.style.display="none";
        stop_talk.style.display="";
    }
    
    delete talkXmlDoc;
}

function OnStopTalk()
{
    if(!g_bTalking)
    {
        return;
    }
    
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_LM_STOP_TALK+"\">\r\n";
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    WebClient.ExcuteLocalCmd(strRequest);
        
    g_bTalking = false;
    start_talk.style.display="";
    stop_talk.style.display="none";
}

function RemoteManualRec()
{
    var strRequest = CreateReqManualRecXml();
    var strReply = WebClient.ExcuteCmd(strRequest);
    
    if(strReply != "")
    {
        var recXmlDoc;// = createXMLDoc();
        //zld 2010/8/18
        recXmlDoc = FormatToXmlDOM(strReply);
        recXmlDoc.async = false;
        //recXmlDoc.loadXML(strReply);
        
        var cmdElements = talkXmlDoc.documentElement.childNodes;
        if((cmdElements.length > 0) && (cmdElements[0].getAttribute("name") == STR_REPLY_NO_AUTH))
        {
            window.alert(str_no_auth);
        }
    }
}